/* AsyncTask.c generated by valac 0.56.17, the Vala compiler
 * generated from AsyncTask.vala, do not modify */

/*
 * AsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gio/gunixoutputstream.h>
#include <gio/gunixinputstream.h>
#include <unistd.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;
typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

#define TYPE_APP_STATUS (app_status_get_type ())
enum  {
	ASYNC_TASK_0_PROPERTY,
	ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY,
	ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY,
	ASYNC_TASK_NUM_PROPERTIES
};
static GParamSpec* async_task_properties[ASYNC_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	ASYNC_TASK_STDOUT_LINE_READ_SIGNAL,
	ASYNC_TASK_STDERR_LINE_READ_SIGNAL,
	ASYNC_TASK_TASK_COMPLETE_SIGNAL,
	ASYNC_TASK_NUM_SIGNALS
};
static guint async_task_signals[ASYNC_TASK_NUM_SIGNALS] = {0};

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _AsyncTaskPrivate {
	gchar* err_line;
	gchar* out_line;
	GDataOutputStream* dos_in;
	GDataInputStream* dis_out;
	GDataInputStream* dis_err;
	gboolean stdout_is_open;
	gboolean stderr_is_open;
	gint input_fd;
	gint output_fd;
	gint error_fd;
	gboolean finish_called;
};

static gint AsyncTask_private_offset;
static gpointer async_task_parent_class = NULL;
VALA_EXTERN gchar* tee_jee_process_helper_TEMP_DIR;

VALA_EXTERN GType async_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AsyncTask, g_object_unref)
VALA_EXTERN GType app_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void async_task_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line);
VALA_EXTERN void async_task_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line);
VALA_EXTERN void async_task_finish_task (AsyncTask* self);
VALA_EXTERN AsyncTask* async_task_construct (GType object_type);
VALA_EXTERN gchar* tee_jee_misc_timestamp_for_path (void);
VALA_EXTERN gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
VALA_EXTERN gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
VALA_EXTERN gboolean async_task_begin (AsyncTask* self);
VALA_EXTERN void async_task_set_priority (AsyncTask* self);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
static void async_task_read_stdout (AsyncTask* self);
static gpointer _async_task_read_stdout_gthread_func (gpointer self);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
static void async_task_read_stderr (AsyncTask* self);
static gpointer _async_task_read_stderr_gthread_func (gpointer self);
static void async_task_finish (AsyncTask* self);
VALA_EXTERN void async_task_write_stdin (AsyncTask* self,
                             const gchar* line);
static void async_task_real_parse_stdout_line (AsyncTask* self,
                                        const gchar* out_line);
static void async_task_real_parse_stderr_line (AsyncTask* self,
                                        const gchar* err_line);
VALA_EXTERN gint async_task_read_exit_code (AsyncTask* self);
static void async_task_real_finish_task (AsyncTask* self);
VALA_EXTERN gchar* tee_jee_file_system_file_parent (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_exists (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_file_read (const gchar* file_path);
VALA_EXTERN gboolean async_task_is_running (AsyncTask* self);
VALA_EXTERN void async_task_stop (AsyncTask* self,
                      AppStatus status_to_update);
VALA_EXTERN void tee_jee_process_helper_process_quit (GPid process_pid,
                                          gboolean killChildren);
VALA_EXTERN void async_task_set_priority_value (AsyncTask* self,
                                    gint prio);
VALA_EXTERN void tee_jee_process_helper_process_set_priority (GPid procID,
                                                  gint prio);
VALA_EXTERN gint* tee_jee_process_helper_get_process_children (GPid parent_pid,
                                                   gint* result_length1);
VALA_EXTERN void async_task_print_app_status (AsyncTask* self);
VALA_EXTERN gchar* async_task_get_stat_time_elapsed (AsyncTask* self);
VALA_EXTERN gulong tee_jee_system_timer_elapsed (GTimer* timer,
                                     gboolean stop);
VALA_EXTERN gchar* tee_jee_misc_format_duration (glong millis);
VALA_EXTERN gchar* async_task_get_stat_time_remaining (AsyncTask* self);
static void async_task_finalize (GObject * obj);
static GType async_task_get_type_once (void);
static void _vala_async_task_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
async_task_get_instance_private (AsyncTask* self)
{
	return G_STRUCT_MEMBER_P (self, AsyncTask_private_offset);
}

AsyncTask*
async_task_construct (GType object_type)
{
	AsyncTask * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
#line 76 "Utility/AsyncTask.vala"
	self = (AsyncTask*) g_object_new (object_type, NULL);
#line 78 "Utility/AsyncTask.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 78 "Utility/AsyncTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 78 "Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 78 "Utility/AsyncTask.vala"
	_tmp3_ = tee_jee_misc_timestamp_for_path ();
#line 78 "Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 78 "Utility/AsyncTask.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 78 "Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 78 "Utility/AsyncTask.vala"
	self->working_dir = _tmp5_;
#line 78 "Utility/AsyncTask.vala"
	_g_free0 (_tmp4_);
#line 78 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 79 "Utility/AsyncTask.vala"
	_tmp6_ = self->working_dir;
#line 79 "Utility/AsyncTask.vala"
	_tmp7_ = tee_jee_file_system_path_combine (_tmp6_, "script.sh");
#line 79 "Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 79 "Utility/AsyncTask.vala"
	self->script_file = _tmp7_;
#line 80 "Utility/AsyncTask.vala"
	_tmp8_ = self->working_dir;
#line 80 "Utility/AsyncTask.vala"
	_tmp9_ = tee_jee_file_system_path_combine (_tmp8_, "task.log");
#line 80 "Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 80 "Utility/AsyncTask.vala"
	self->log_file = _tmp9_;
#line 84 "Utility/AsyncTask.vala"
	_tmp10_ = self->working_dir;
#line 84 "Utility/AsyncTask.vala"
	tee_jee_file_system_dir_create (_tmp10_, FALSE);
#line 76 "Utility/AsyncTask.vala"
	return self;
#line 277 "AsyncTask.c"
}

static gpointer
_async_task_read_stdout_gthread_func (gpointer self)
{
	gpointer result;
#line 147 "Utility/AsyncTask.vala"
	async_task_read_stdout ((AsyncTask*) self);
#line 286 "AsyncTask.c"
	result = NULL;
#line 147 "Utility/AsyncTask.vala"
	g_object_unref (self);
#line 147 "Utility/AsyncTask.vala"
	return result;
#line 292 "AsyncTask.c"
}

static gpointer
_async_task_read_stderr_gthread_func (gpointer self)
{
	gpointer result;
#line 155 "Utility/AsyncTask.vala"
	async_task_read_stderr ((AsyncTask*) self);
#line 301 "AsyncTask.c"
	result = NULL;
#line 155 "Utility/AsyncTask.vala"
	g_object_unref (self);
#line 155 "Utility/AsyncTask.vala"
	return result;
#line 307 "AsyncTask.c"
}

gboolean
async_task_begin (AsyncTask* self)
{
	gboolean has_started = FALSE;
	gchar* _tmp0_;
	gchar** spawn_args = NULL;
	gchar** _tmp1_;
	gint spawn_args_length1;
	gint _spawn_args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** spawn_env = NULL;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 87 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "Utility/AsyncTask.vala"
	self->status = APP_STATUS_RUNNING;
#line 91 "Utility/AsyncTask.vala"
	has_started = TRUE;
#line 92 "Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 93 "Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 95 "Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 96 "Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 97 "Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 97 "Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 97 "Utility/AsyncTask.vala"
	self->error_msg = _tmp0_;
#line 99 "Utility/AsyncTask.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 99 "Utility/AsyncTask.vala"
	spawn_args = _tmp1_;
#line 99 "Utility/AsyncTask.vala"
	spawn_args_length1 = 1;
#line 99 "Utility/AsyncTask.vala"
	_spawn_args_size_ = spawn_args_length1;
#line 100 "Utility/AsyncTask.vala"
	_tmp2_ = spawn_args;
#line 100 "Utility/AsyncTask.vala"
	_tmp2__length1 = spawn_args_length1;
#line 100 "Utility/AsyncTask.vala"
	_tmp3_ = self->script_file;
#line 100 "Utility/AsyncTask.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 100 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_[0]);
#line 100 "Utility/AsyncTask.vala"
	_tmp2_[0] = _tmp4_;
#line 102 "Utility/AsyncTask.vala"
	_tmp6_ = _tmp5_ = g_get_environ ();
#line 102 "Utility/AsyncTask.vala"
	spawn_env = _tmp6_;
#line 102 "Utility/AsyncTask.vala"
	spawn_env_length1 = _vala_array_length (_tmp5_);
#line 102 "Utility/AsyncTask.vala"
	_spawn_env_size_ = spawn_env_length1;
#line 378 "AsyncTask.c"
	{
		GTimer* _tmp7_;
		GTimer* _tmp8_;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar** _tmp11_;
		gint _tmp11__length1;
		GPid _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GUnixOutputStream* uos_in = NULL;
		GUnixOutputStream* _tmp18_;
		GUnixInputStream* uis_out = NULL;
		GUnixInputStream* _tmp19_;
		GUnixInputStream* uis_err = NULL;
		GUnixInputStream* _tmp20_;
		GUnixOutputStream* _tmp21_;
		GDataOutputStream* _tmp22_;
		GUnixInputStream* _tmp23_;
		GDataInputStream* _tmp24_;
		GUnixInputStream* _tmp25_;
		GDataInputStream* _tmp26_;
		GDataInputStream* _tmp27_;
		GDataInputStream* _tmp28_;
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 106 "Utility/AsyncTask.vala"
		_tmp7_ = g_timer_new ();
#line 106 "Utility/AsyncTask.vala"
		_g_timer_destroy0 (self->timer);
#line 106 "Utility/AsyncTask.vala"
		self->timer = _tmp7_;
#line 107 "Utility/AsyncTask.vala"
		_tmp8_ = self->timer;
#line 107 "Utility/AsyncTask.vala"
		g_timer_start (_tmp8_);
#line 110 "Utility/AsyncTask.vala"
		_tmp9_ = self->working_dir;
#line 110 "Utility/AsyncTask.vala"
		_tmp10_ = spawn_args;
#line 110 "Utility/AsyncTask.vala"
		_tmp10__length1 = spawn_args_length1;
#line 110 "Utility/AsyncTask.vala"
		_tmp11_ = spawn_env;
#line 110 "Utility/AsyncTask.vala"
		_tmp11__length1 = spawn_env_length1;
#line 110 "Utility/AsyncTask.vala"
		g_spawn_async_with_pipes (_tmp9_, _tmp10_, _tmp11_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 110 "Utility/AsyncTask.vala"
		self->child_pid = _tmp12_;
#line 110 "Utility/AsyncTask.vala"
		self->priv->input_fd = _tmp13_;
#line 110 "Utility/AsyncTask.vala"
		self->priv->output_fd = _tmp14_;
#line 110 "Utility/AsyncTask.vala"
		self->priv->error_fd = _tmp15_;
#line 110 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 442 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 121 "Utility/AsyncTask.vala"
		async_task_set_priority (self);
#line 123 "Utility/AsyncTask.vala"
		_tmp16_ = g_strdup_printf ("AsyncTask: child_pid: %d", (gint) self->child_pid);
#line 123 "Utility/AsyncTask.vala"
		_tmp17_ = _tmp16_;
#line 123 "Utility/AsyncTask.vala"
		tee_jee_logging_log_debug (_tmp17_);
#line 123 "Utility/AsyncTask.vala"
		_g_free0 (_tmp17_);
#line 126 "Utility/AsyncTask.vala"
		_tmp18_ = (GUnixOutputStream*) g_unix_output_stream_new (self->priv->input_fd, FALSE);
#line 126 "Utility/AsyncTask.vala"
		uos_in = _tmp18_;
#line 127 "Utility/AsyncTask.vala"
		_tmp19_ = (GUnixInputStream*) g_unix_input_stream_new (self->priv->output_fd, FALSE);
#line 127 "Utility/AsyncTask.vala"
		uis_out = _tmp19_;
#line 128 "Utility/AsyncTask.vala"
		_tmp20_ = (GUnixInputStream*) g_unix_input_stream_new (self->priv->error_fd, FALSE);
#line 128 "Utility/AsyncTask.vala"
		uis_err = _tmp20_;
#line 129 "Utility/AsyncTask.vala"
		_tmp21_ = uos_in;
#line 129 "Utility/AsyncTask.vala"
		_tmp22_ = g_data_output_stream_new ((GOutputStream*) _tmp21_);
#line 129 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dos_in);
#line 129 "Utility/AsyncTask.vala"
		self->priv->dos_in = _tmp22_;
#line 130 "Utility/AsyncTask.vala"
		_tmp23_ = uis_out;
#line 130 "Utility/AsyncTask.vala"
		_tmp24_ = g_data_input_stream_new ((GInputStream*) _tmp23_);
#line 130 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 130 "Utility/AsyncTask.vala"
		self->priv->dis_out = _tmp24_;
#line 131 "Utility/AsyncTask.vala"
		_tmp25_ = uis_err;
#line 131 "Utility/AsyncTask.vala"
		_tmp26_ = g_data_input_stream_new ((GInputStream*) _tmp25_);
#line 131 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 131 "Utility/AsyncTask.vala"
		self->priv->dis_err = _tmp26_;
#line 132 "Utility/AsyncTask.vala"
		_tmp27_ = self->priv->dis_out;
#line 132 "Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp27_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 133 "Utility/AsyncTask.vala"
		_tmp28_ = self->priv->dis_err;
#line 133 "Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp28_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 136 "Utility/AsyncTask.vala"
		_tmp29_ = self->log_file;
#line 136 "Utility/AsyncTask.vala"
		_tmp30_ = strlen (_tmp29_);
#line 136 "Utility/AsyncTask.vala"
		_tmp31_ = _tmp30_;
#line 136 "Utility/AsyncTask.vala"
		if (_tmp31_ > 0) {
#line 507 "AsyncTask.c"
			GFile* file = NULL;
			const gchar* _tmp32_;
			GFile* _tmp33_;
			GFile* _tmp34_;
			GFileOutputStream* file_stream = NULL;
			GFile* _tmp36_;
			GFileOutputStream* _tmp37_;
			GFileOutputStream* _tmp38_;
			GDataOutputStream* _tmp39_;
#line 137 "Utility/AsyncTask.vala"
			_tmp32_ = self->log_file;
#line 137 "Utility/AsyncTask.vala"
			_tmp33_ = g_file_new_for_path (_tmp32_);
#line 137 "Utility/AsyncTask.vala"
			file = _tmp33_;
#line 138 "Utility/AsyncTask.vala"
			_tmp34_ = file;
#line 138 "Utility/AsyncTask.vala"
			if (g_file_query_exists (_tmp34_, NULL)) {
#line 527 "AsyncTask.c"
				GFile* _tmp35_;
#line 139 "Utility/AsyncTask.vala"
				_tmp35_ = file;
#line 139 "Utility/AsyncTask.vala"
				g_file_delete (_tmp35_, NULL, &_inner_error0_);
#line 139 "Utility/AsyncTask.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "Utility/AsyncTask.vala"
					_g_object_unref0 (file);
#line 139 "Utility/AsyncTask.vala"
					_g_object_unref0 (uis_err);
#line 139 "Utility/AsyncTask.vala"
					_g_object_unref0 (uis_out);
#line 139 "Utility/AsyncTask.vala"
					_g_object_unref0 (uos_in);
#line 543 "AsyncTask.c"
					goto __catch0_g_error;
				}
			}
#line 141 "Utility/AsyncTask.vala"
			_tmp36_ = file;
#line 141 "Utility/AsyncTask.vala"
			_tmp37_ = g_file_create (_tmp36_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 141 "Utility/AsyncTask.vala"
			file_stream = _tmp37_;
#line 141 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "Utility/AsyncTask.vala"
				_g_object_unref0 (file);
#line 141 "Utility/AsyncTask.vala"
				_g_object_unref0 (uis_err);
#line 141 "Utility/AsyncTask.vala"
				_g_object_unref0 (uis_out);
#line 141 "Utility/AsyncTask.vala"
				_g_object_unref0 (uos_in);
#line 563 "AsyncTask.c"
				goto __catch0_g_error;
			}
#line 142 "Utility/AsyncTask.vala"
			_tmp38_ = file_stream;
#line 142 "Utility/AsyncTask.vala"
			_tmp39_ = g_data_output_stream_new ((GOutputStream*) _tmp38_);
#line 142 "Utility/AsyncTask.vala"
			_g_object_unref0 (self->dos_log);
#line 142 "Utility/AsyncTask.vala"
			self->dos_log = _tmp39_;
#line 136 "Utility/AsyncTask.vala"
			_g_object_unref0 (file_stream);
#line 136 "Utility/AsyncTask.vala"
			_g_object_unref0 (file);
#line 578 "AsyncTask.c"
		}
		{
#line 147 "Utility/AsyncTask.vala"
			g_thread_create (_async_task_read_stdout_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 147 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 585 "AsyncTask.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp40_;
			const gchar* _tmp41_;
#line 145 "Utility/AsyncTask.vala"
			e = _inner_error0_;
#line 145 "Utility/AsyncTask.vala"
			_inner_error0_ = NULL;
#line 149 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stdout()", FALSE, FALSE);
#line 150 "Utility/AsyncTask.vala"
			_tmp40_ = e;
#line 150 "Utility/AsyncTask.vala"
			_tmp41_ = _tmp40_->message;
#line 150 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp41_, FALSE, FALSE);
#line 145 "Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 609 "AsyncTask.c"
		}
		__finally1:
#line 145 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 145 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 145 "Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 620 "AsyncTask.c"
			goto __catch0_g_error;
		}
		{
#line 155 "Utility/AsyncTask.vala"
			g_thread_create (_async_task_read_stderr_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 155 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 628 "AsyncTask.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 153 "Utility/AsyncTask.vala"
			e = _inner_error0_;
#line 153 "Utility/AsyncTask.vala"
			_inner_error0_ = NULL;
#line 157 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stderr()", FALSE, FALSE);
#line 158 "Utility/AsyncTask.vala"
			_tmp42_ = e;
#line 158 "Utility/AsyncTask.vala"
			_tmp43_ = _tmp42_->message;
#line 158 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp43_, FALSE, FALSE);
#line 153 "Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 652 "AsyncTask.c"
		}
		__finally2:
#line 153 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 153 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 153 "Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 663 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 104 "Utility/AsyncTask.vala"
		_g_object_unref0 (uis_err);
#line 104 "Utility/AsyncTask.vala"
		_g_object_unref0 (uis_out);
#line 104 "Utility/AsyncTask.vala"
		_g_object_unref0 (uos_in);
#line 672 "AsyncTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp44_;
		const gchar* _tmp45_;
#line 104 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 104 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 162 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.begin()", FALSE, FALSE);
#line 163 "Utility/AsyncTask.vala"
		_tmp44_ = e;
#line 163 "Utility/AsyncTask.vala"
		_tmp45_ = _tmp44_->message;
#line 163 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp45_, FALSE, FALSE);
#line 164 "Utility/AsyncTask.vala"
		has_started = FALSE;
#line 104 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 696 "AsyncTask.c"
	}
	__finally0:
#line 104 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 701 "AsyncTask.c"
		gboolean _tmp46_ = FALSE;
#line 104 "Utility/AsyncTask.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 104 "Utility/AsyncTask.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 104 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 104 "Utility/AsyncTask.vala"
		return _tmp46_;
#line 713 "AsyncTask.c"
	}
#line 168 "Utility/AsyncTask.vala"
	result = has_started;
#line 168 "Utility/AsyncTask.vala"
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 168 "Utility/AsyncTask.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 168 "Utility/AsyncTask.vala"
	return result;
#line 723 "AsyncTask.c"
}

static void
async_task_read_stdout (AsyncTask* self)
{
	GError* _inner_error0_ = NULL;
#line 171 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 732 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp15_ = FALSE;
		GDataInputStream* _tmp16_;
		gboolean _tmp19_ = FALSE;
#line 173 "Utility/AsyncTask.vala"
		self->priv->stdout_is_open = TRUE;
#line 175 "Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_out;
#line 175 "Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error0_);
#line 175 "Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 175 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 751 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 175 "Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 175 "Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 175 "Utility/AsyncTask.vala"
		_g_free0 (self->priv->out_line);
#line 175 "Utility/AsyncTask.vala"
		self->priv->out_line = _tmp3_;
#line 176 "Utility/AsyncTask.vala"
		while (TRUE) {
#line 764 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gchar* _tmp11_ = NULL;
			GDataInputStream* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 176 "Utility/AsyncTask.vala"
			_tmp4_ = self->priv->out_line;
#line 176 "Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 176 "Utility/AsyncTask.vala"
				break;
#line 777 "AsyncTask.c"
			}
#line 178 "Utility/AsyncTask.vala"
			if (!self->is_terminated) {
#line 781 "AsyncTask.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 178 "Utility/AsyncTask.vala"
				_tmp6_ = self->priv->out_line;
#line 178 "Utility/AsyncTask.vala"
				_tmp7_ = strlen (_tmp6_);
#line 178 "Utility/AsyncTask.vala"
				_tmp8_ = _tmp7_;
#line 178 "Utility/AsyncTask.vala"
				_tmp5_ = _tmp8_ > 0;
#line 793 "AsyncTask.c"
			} else {
#line 178 "Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 797 "AsyncTask.c"
			}
#line 178 "Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 801 "AsyncTask.c"
				const gchar* _tmp9_;
				const gchar* _tmp10_;
#line 179 "Utility/AsyncTask.vala"
				_tmp9_ = self->priv->out_line;
#line 179 "Utility/AsyncTask.vala"
				async_task_parse_stdout_line (self, _tmp9_);
#line 180 "Utility/AsyncTask.vala"
				_tmp10_ = self->priv->out_line;
#line 180 "Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL], 0, _tmp10_);
#line 812 "AsyncTask.c"
			}
#line 182 "Utility/AsyncTask.vala"
			_tmp12_ = self->priv->dis_out;
#line 182 "Utility/AsyncTask.vala"
			_tmp13_ = g_data_input_stream_read_line (_tmp12_, NULL, NULL, &_inner_error0_);
#line 182 "Utility/AsyncTask.vala"
			_tmp11_ = _tmp13_;
#line 182 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 824 "AsyncTask.c"
				goto __catch0_g_error;
			}
#line 182 "Utility/AsyncTask.vala"
			_tmp14_ = _tmp11_;
#line 182 "Utility/AsyncTask.vala"
			_tmp11_ = NULL;
#line 182 "Utility/AsyncTask.vala"
			_g_free0 (self->priv->out_line);
#line 182 "Utility/AsyncTask.vala"
			self->priv->out_line = _tmp14_;
#line 176 "Utility/AsyncTask.vala"
			_g_free0 (_tmp11_);
#line 837 "AsyncTask.c"
		}
#line 185 "Utility/AsyncTask.vala"
		self->priv->stdout_is_open = FALSE;
#line 188 "Utility/AsyncTask.vala"
		_tmp16_ = self->priv->dis_out;
#line 188 "Utility/AsyncTask.vala"
		if (_tmp16_ != NULL) {
#line 845 "AsyncTask.c"
			GDataInputStream* _tmp17_;
#line 188 "Utility/AsyncTask.vala"
			_tmp17_ = self->priv->dis_out;
#line 188 "Utility/AsyncTask.vala"
			_tmp15_ = !g_input_stream_is_closed ((GInputStream*) _tmp17_);
#line 851 "AsyncTask.c"
		} else {
#line 188 "Utility/AsyncTask.vala"
			_tmp15_ = FALSE;
#line 855 "AsyncTask.c"
		}
#line 188 "Utility/AsyncTask.vala"
		if (_tmp15_) {
#line 859 "AsyncTask.c"
			GDataInputStream* _tmp18_;
#line 189 "Utility/AsyncTask.vala"
			_tmp18_ = self->priv->dis_out;
#line 189 "Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp18_, NULL, &_inner_error0_);
#line 189 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 869 "AsyncTask.c"
				goto __catch0_g_error;
			}
		}
#line 192 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 192 "Utility/AsyncTask.vala"
		self->priv->dis_out = NULL;
#line 193 "Utility/AsyncTask.vala"
		close (self->priv->output_fd);
#line 196 "Utility/AsyncTask.vala"
		if (!self->priv->stdout_is_open) {
#line 196 "Utility/AsyncTask.vala"
			_tmp19_ = !self->priv->stderr_is_open;
#line 883 "AsyncTask.c"
		} else {
#line 196 "Utility/AsyncTask.vala"
			_tmp19_ = FALSE;
#line 887 "AsyncTask.c"
		}
#line 196 "Utility/AsyncTask.vala"
		if (_tmp19_) {
#line 197 "Utility/AsyncTask.vala"
			async_task_finish (self);
#line 893 "AsyncTask.c"
		}
#line 172 "Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 897 "AsyncTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 172 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 172 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 201 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stdout()", FALSE, FALSE);
#line 202 "Utility/AsyncTask.vala"
		_tmp20_ = e;
#line 202 "Utility/AsyncTask.vala"
		_tmp21_ = _tmp20_->message;
#line 202 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp21_, FALSE, FALSE);
#line 172 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 919 "AsyncTask.c"
	}
	__finally0:
#line 172 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 172 "Utility/AsyncTask.vala"
		return;
#line 930 "AsyncTask.c"
	}
}

static void
async_task_read_stderr (AsyncTask* self)
{
	GError* _inner_error0_ = NULL;
#line 206 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 940 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp20_ = FALSE;
		GDataInputStream* _tmp21_;
		gboolean _tmp24_ = FALSE;
#line 208 "Utility/AsyncTask.vala"
		self->priv->stderr_is_open = TRUE;
#line 210 "Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_err;
#line 210 "Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error0_);
#line 210 "Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 210 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 959 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 210 "Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 210 "Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 210 "Utility/AsyncTask.vala"
		_g_free0 (self->priv->err_line);
#line 210 "Utility/AsyncTask.vala"
		self->priv->err_line = _tmp3_;
#line 211 "Utility/AsyncTask.vala"
		while (TRUE) {
#line 972 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gchar* _tmp16_ = NULL;
			GDataInputStream* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 211 "Utility/AsyncTask.vala"
			_tmp4_ = self->priv->err_line;
#line 211 "Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 211 "Utility/AsyncTask.vala"
				break;
#line 985 "AsyncTask.c"
			}
#line 212 "Utility/AsyncTask.vala"
			if (!self->is_terminated) {
#line 989 "AsyncTask.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 212 "Utility/AsyncTask.vala"
				_tmp6_ = self->priv->err_line;
#line 212 "Utility/AsyncTask.vala"
				_tmp7_ = strlen (_tmp6_);
#line 212 "Utility/AsyncTask.vala"
				_tmp8_ = _tmp7_;
#line 212 "Utility/AsyncTask.vala"
				_tmp5_ = _tmp8_ > 0;
#line 1001 "AsyncTask.c"
			} else {
#line 212 "Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 1005 "AsyncTask.c"
			}
#line 212 "Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 1009 "AsyncTask.c"
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 213 "Utility/AsyncTask.vala"
				_tmp9_ = self->error_msg;
#line 213 "Utility/AsyncTask.vala"
				_tmp10_ = self->priv->err_line;
#line 213 "Utility/AsyncTask.vala"
				_tmp11_ = g_strdup_printf ("%s\n", _tmp10_);
#line 213 "Utility/AsyncTask.vala"
				_tmp12_ = _tmp11_;
#line 213 "Utility/AsyncTask.vala"
				_tmp13_ = g_strconcat (_tmp9_, _tmp12_, NULL);
#line 213 "Utility/AsyncTask.vala"
				_g_free0 (self->error_msg);
#line 213 "Utility/AsyncTask.vala"
				self->error_msg = _tmp13_;
#line 213 "Utility/AsyncTask.vala"
				_g_free0 (_tmp12_);
#line 215 "Utility/AsyncTask.vala"
				_tmp14_ = self->priv->err_line;
#line 215 "Utility/AsyncTask.vala"
				async_task_parse_stderr_line (self, _tmp14_);
#line 216 "Utility/AsyncTask.vala"
				_tmp15_ = self->priv->err_line;
#line 216 "Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL], 0, _tmp15_);
#line 1041 "AsyncTask.c"
			}
#line 218 "Utility/AsyncTask.vala"
			_tmp17_ = self->priv->dis_err;
#line 218 "Utility/AsyncTask.vala"
			_tmp18_ = g_data_input_stream_read_line (_tmp17_, NULL, NULL, &_inner_error0_);
#line 218 "Utility/AsyncTask.vala"
			_tmp16_ = _tmp18_;
#line 218 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1053 "AsyncTask.c"
				goto __catch0_g_error;
			}
#line 218 "Utility/AsyncTask.vala"
			_tmp19_ = _tmp16_;
#line 218 "Utility/AsyncTask.vala"
			_tmp16_ = NULL;
#line 218 "Utility/AsyncTask.vala"
			_g_free0 (self->priv->err_line);
#line 218 "Utility/AsyncTask.vala"
			self->priv->err_line = _tmp19_;
#line 211 "Utility/AsyncTask.vala"
			_g_free0 (_tmp16_);
#line 1066 "AsyncTask.c"
		}
#line 221 "Utility/AsyncTask.vala"
		self->priv->stderr_is_open = FALSE;
#line 224 "Utility/AsyncTask.vala"
		_tmp21_ = self->priv->dis_err;
#line 224 "Utility/AsyncTask.vala"
		if (_tmp21_ != NULL) {
#line 1074 "AsyncTask.c"
			GDataInputStream* _tmp22_;
#line 224 "Utility/AsyncTask.vala"
			_tmp22_ = self->priv->dis_err;
#line 224 "Utility/AsyncTask.vala"
			_tmp20_ = !g_input_stream_is_closed ((GInputStream*) _tmp22_);
#line 1080 "AsyncTask.c"
		} else {
#line 224 "Utility/AsyncTask.vala"
			_tmp20_ = FALSE;
#line 1084 "AsyncTask.c"
		}
#line 224 "Utility/AsyncTask.vala"
		if (_tmp20_) {
#line 1088 "AsyncTask.c"
			GDataInputStream* _tmp23_;
#line 225 "Utility/AsyncTask.vala"
			_tmp23_ = self->priv->dis_err;
#line 225 "Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp23_, NULL, &_inner_error0_);
#line 225 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1098 "AsyncTask.c"
				goto __catch0_g_error;
			}
		}
#line 228 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 228 "Utility/AsyncTask.vala"
		self->priv->dis_err = NULL;
#line 229 "Utility/AsyncTask.vala"
		close (self->priv->error_fd);
#line 232 "Utility/AsyncTask.vala"
		if (!self->priv->stdout_is_open) {
#line 232 "Utility/AsyncTask.vala"
			_tmp24_ = !self->priv->stderr_is_open;
#line 1112 "AsyncTask.c"
		} else {
#line 232 "Utility/AsyncTask.vala"
			_tmp24_ = FALSE;
#line 1116 "AsyncTask.c"
		}
#line 232 "Utility/AsyncTask.vala"
		if (_tmp24_) {
#line 233 "Utility/AsyncTask.vala"
			async_task_finish (self);
#line 1122 "AsyncTask.c"
		}
#line 207 "Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 1126 "AsyncTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 207 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 207 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 237 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stderr()", FALSE, FALSE);
#line 238 "Utility/AsyncTask.vala"
		_tmp25_ = e;
#line 238 "Utility/AsyncTask.vala"
		_tmp26_ = _tmp25_->message;
#line 238 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp26_, FALSE, FALSE);
#line 207 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1148 "AsyncTask.c"
	}
	__finally0:
#line 207 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 207 "Utility/AsyncTask.vala"
		return;
#line 1159 "AsyncTask.c"
	}
}

void
async_task_write_stdin (AsyncTask* self,
                        const gchar* line)
{
	GError* _inner_error0_ = NULL;
#line 242 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 242 "Utility/AsyncTask.vala"
	g_return_if_fail (line != NULL);
#line 1172 "AsyncTask.c"
	{
#line 244 "Utility/AsyncTask.vala"
		if (self->status == APP_STATUS_RUNNING) {
#line 1176 "AsyncTask.c"
			GDataOutputStream* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 245 "Utility/AsyncTask.vala"
			_tmp0_ = self->priv->dos_in;
#line 245 "Utility/AsyncTask.vala"
			_tmp1_ = g_strconcat (line, "\n", NULL);
#line 245 "Utility/AsyncTask.vala"
			_tmp2_ = _tmp1_;
#line 245 "Utility/AsyncTask.vala"
			g_data_output_stream_put_string (_tmp0_, _tmp2_, NULL, &_inner_error0_);
#line 245 "Utility/AsyncTask.vala"
			_g_free0 (_tmp2_);
#line 245 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1192 "AsyncTask.c"
				goto __catch0_g_error;
			}
		} else {
#line 248 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.write_stdin(): NOT RUNNING", FALSE, FALSE);
#line 1198 "AsyncTask.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 243 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 243 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 252 "Utility/AsyncTask.vala"
		_tmp3_ = g_strdup_printf ("AsyncTask.write_stdin(): %s", line);
#line 252 "Utility/AsyncTask.vala"
		_tmp4_ = _tmp3_;
#line 252 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 252 "Utility/AsyncTask.vala"
		_g_free0 (_tmp4_);
#line 253 "Utility/AsyncTask.vala"
		_tmp5_ = e;
#line 253 "Utility/AsyncTask.vala"
		_tmp6_ = _tmp5_->message;
#line 253 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 243 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1229 "AsyncTask.c"
	}
	__finally0:
#line 243 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 243 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 243 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 243 "Utility/AsyncTask.vala"
		return;
#line 1240 "AsyncTask.c"
	}
}

static void
async_task_real_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line)
{
#line 257 "Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stdout_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 257 "Utility/AsyncTask.vala"
	return;
#line 1252 "AsyncTask.c"
}

void
async_task_parse_stdout_line (AsyncTask* self,
                              const gchar* out_line)
{
	AsyncTaskClass* _klass_;
#line 257 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 257 "Utility/AsyncTask.vala"
	_klass_ = ASYNC_TASK_GET_CLASS (self);
#line 257 "Utility/AsyncTask.vala"
	if (_klass_->parse_stdout_line) {
#line 257 "Utility/AsyncTask.vala"
		_klass_->parse_stdout_line (self, out_line);
#line 1268 "AsyncTask.c"
	}
}

static void
async_task_real_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line)
{
#line 259 "Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stderr_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 259 "Utility/AsyncTask.vala"
	return;
#line 1280 "AsyncTask.c"
}

void
async_task_parse_stderr_line (AsyncTask* self,
                              const gchar* err_line)
{
	AsyncTaskClass* _klass_;
#line 259 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 259 "Utility/AsyncTask.vala"
	_klass_ = ASYNC_TASK_GET_CLASS (self);
#line 259 "Utility/AsyncTask.vala"
	if (_klass_->parse_stderr_line) {
#line 259 "Utility/AsyncTask.vala"
		_klass_->parse_stderr_line (self, err_line);
#line 1296 "AsyncTask.c"
	}
}

static void
async_task_finish (AsyncTask* self)
{
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GTimer* _tmp15_;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 261 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 264 "Utility/AsyncTask.vala"
	if (self->priv->finish_called) {
#line 264 "Utility/AsyncTask.vala"
		return;
#line 1315 "AsyncTask.c"
	}
#line 265 "Utility/AsyncTask.vala"
	self->priv->finish_called = TRUE;
#line 267 "Utility/AsyncTask.vala"
	tee_jee_logging_log_debug ("AsyncTask: finish(): enter");
#line 1321 "AsyncTask.c"
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GDataOutputStream* _tmp2_;
#line 271 "Utility/AsyncTask.vala"
		_tmp2_ = self->priv->dos_in;
#line 271 "Utility/AsyncTask.vala"
		if (_tmp2_ != NULL) {
#line 1330 "AsyncTask.c"
			GDataOutputStream* _tmp3_;
#line 271 "Utility/AsyncTask.vala"
			_tmp3_ = self->priv->dos_in;
#line 271 "Utility/AsyncTask.vala"
			_tmp1_ = !g_output_stream_is_closed ((GOutputStream*) _tmp3_);
#line 1336 "AsyncTask.c"
		} else {
#line 271 "Utility/AsyncTask.vala"
			_tmp1_ = FALSE;
#line 1340 "AsyncTask.c"
		}
#line 271 "Utility/AsyncTask.vala"
		if (_tmp1_) {
#line 1344 "AsyncTask.c"
			GDataOutputStream* _tmp4_;
#line 271 "Utility/AsyncTask.vala"
			_tmp4_ = self->priv->dos_in;
#line 271 "Utility/AsyncTask.vala"
			_tmp0_ = !g_output_stream_is_closing ((GOutputStream*) _tmp4_);
#line 1350 "AsyncTask.c"
		} else {
#line 271 "Utility/AsyncTask.vala"
			_tmp0_ = FALSE;
#line 1354 "AsyncTask.c"
		}
#line 271 "Utility/AsyncTask.vala"
		if (_tmp0_) {
#line 1358 "AsyncTask.c"
			GDataOutputStream* _tmp5_;
#line 272 "Utility/AsyncTask.vala"
			_tmp5_ = self->priv->dos_in;
#line 272 "Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp5_, NULL, &_inner_error0_);
#line 272 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1366 "AsyncTask.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 270 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 1376 "AsyncTask.c"
	}
	__finally0:
#line 270 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 270 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 270 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 270 "Utility/AsyncTask.vala"
		return;
#line 1387 "AsyncTask.c"
	}
#line 281 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 281 "Utility/AsyncTask.vala"
	self->priv->dos_in = NULL;
#line 282 "Utility/AsyncTask.vala"
	close (self->priv->input_fd);
#line 285 "Utility/AsyncTask.vala"
	g_spawn_close_pid (self->child_pid);
#line 1397 "AsyncTask.c"
	{
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		GDataOutputStream* _tmp8_;
#line 289 "Utility/AsyncTask.vala"
		_tmp8_ = self->dos_log;
#line 289 "Utility/AsyncTask.vala"
		if (_tmp8_ != NULL) {
#line 1406 "AsyncTask.c"
			GDataOutputStream* _tmp9_;
#line 289 "Utility/AsyncTask.vala"
			_tmp9_ = self->dos_log;
#line 289 "Utility/AsyncTask.vala"
			_tmp7_ = !g_output_stream_is_closed ((GOutputStream*) _tmp9_);
#line 1412 "AsyncTask.c"
		} else {
#line 289 "Utility/AsyncTask.vala"
			_tmp7_ = FALSE;
#line 1416 "AsyncTask.c"
		}
#line 289 "Utility/AsyncTask.vala"
		if (_tmp7_) {
#line 1420 "AsyncTask.c"
			GDataOutputStream* _tmp10_;
#line 289 "Utility/AsyncTask.vala"
			_tmp10_ = self->dos_log;
#line 289 "Utility/AsyncTask.vala"
			_tmp6_ = !g_output_stream_is_closing ((GOutputStream*) _tmp10_);
#line 1426 "AsyncTask.c"
		} else {
#line 289 "Utility/AsyncTask.vala"
			_tmp6_ = FALSE;
#line 1430 "AsyncTask.c"
		}
#line 289 "Utility/AsyncTask.vala"
		if (_tmp6_) {
#line 1434 "AsyncTask.c"
			GDataOutputStream* _tmp11_;
#line 290 "Utility/AsyncTask.vala"
			_tmp11_ = self->dos_log;
#line 290 "Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp11_, NULL, &_inner_error0_);
#line 290 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1442 "AsyncTask.c"
				goto __catch1_g_error;
			}
		}
#line 292 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->dos_log);
#line 292 "Utility/AsyncTask.vala"
		self->dos_log = NULL;
#line 1450 "AsyncTask.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 287 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 1457 "AsyncTask.c"
	}
	__finally1:
#line 287 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 287 "Utility/AsyncTask.vala"
		return;
#line 1468 "AsyncTask.c"
	}
#line 300 "Utility/AsyncTask.vala"
	async_task_read_exit_code (self);
#line 302 "Utility/AsyncTask.vala"
	_tmp12_ = g_strdup ("");
#line 302 "Utility/AsyncTask.vala"
	_g_free0 (self->status_line);
#line 302 "Utility/AsyncTask.vala"
	self->status_line = _tmp12_;
#line 303 "Utility/AsyncTask.vala"
	_tmp13_ = g_strdup ("");
#line 303 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 303 "Utility/AsyncTask.vala"
	self->priv->err_line = _tmp13_;
#line 304 "Utility/AsyncTask.vala"
	_tmp14_ = g_strdup ("");
#line 304 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 304 "Utility/AsyncTask.vala"
	self->priv->out_line = _tmp14_;
#line 306 "Utility/AsyncTask.vala"
	_tmp15_ = self->timer;
#line 306 "Utility/AsyncTask.vala"
	g_timer_stop (_tmp15_);
#line 308 "Utility/AsyncTask.vala"
	async_task_finish_task (self);
#line 310 "Utility/AsyncTask.vala"
	if (self->status != APP_STATUS_CANCELLED) {
#line 310 "Utility/AsyncTask.vala"
		_tmp16_ = self->status != APP_STATUS_PASSWORD_REQUIRED;
#line 1500 "AsyncTask.c"
	} else {
#line 310 "Utility/AsyncTask.vala"
		_tmp16_ = FALSE;
#line 1504 "AsyncTask.c"
	}
#line 310 "Utility/AsyncTask.vala"
	if (_tmp16_) {
#line 311 "Utility/AsyncTask.vala"
		self->status = APP_STATUS_FINISHED;
#line 1510 "AsyncTask.c"
	}
#line 316 "Utility/AsyncTask.vala"
	g_signal_emit (self, async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL], 0);
#line 1514 "AsyncTask.c"
}

static void
async_task_real_finish_task (AsyncTask* self)
{
#line 319 "Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_finish_task'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 319 "Utility/AsyncTask.vala"
	return;
#line 1524 "AsyncTask.c"
}

void
async_task_finish_task (AsyncTask* self)
{
	AsyncTaskClass* _klass_;
#line 319 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 319 "Utility/AsyncTask.vala"
	_klass_ = ASYNC_TASK_GET_CLASS (self);
#line 319 "Utility/AsyncTask.vala"
	if (_klass_->finish_task) {
#line 319 "Utility/AsyncTask.vala"
		_klass_->finish_task (self);
#line 1539 "AsyncTask.c"
	}
}

gint
async_task_read_exit_code (AsyncTask* self)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint result;
#line 321 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 323 "Utility/AsyncTask.vala"
	self->exit_code = -1;
#line 324 "Utility/AsyncTask.vala"
	_tmp0_ = self->script_file;
#line 324 "Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_file_system_file_parent (_tmp0_);
#line 324 "Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 324 "Utility/AsyncTask.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/status", NULL);
#line 324 "Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 324 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 324 "Utility/AsyncTask.vala"
	path = _tmp4_;
#line 325 "Utility/AsyncTask.vala"
	_tmp5_ = path;
#line 325 "Utility/AsyncTask.vala"
	if (tee_jee_file_system_file_exists (_tmp5_)) {
#line 1578 "AsyncTask.c"
		gchar* txt = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 326 "Utility/AsyncTask.vala"
		_tmp6_ = path;
#line 326 "Utility/AsyncTask.vala"
		_tmp7_ = tee_jee_file_system_file_read (_tmp6_);
#line 326 "Utility/AsyncTask.vala"
		txt = _tmp7_;
#line 327 "Utility/AsyncTask.vala"
		_tmp8_ = txt;
#line 327 "Utility/AsyncTask.vala"
		self->exit_code = atoi (_tmp8_);
#line 325 "Utility/AsyncTask.vala"
		_g_free0 (txt);
#line 1595 "AsyncTask.c"
	}
#line 329 "Utility/AsyncTask.vala"
	_tmp9_ = g_strdup_printf ("exit_code: %d", self->exit_code);
#line 329 "Utility/AsyncTask.vala"
	_tmp10_ = _tmp9_;
#line 329 "Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp10_);
#line 329 "Utility/AsyncTask.vala"
	_g_free0 (_tmp10_);
#line 330 "Utility/AsyncTask.vala"
	result = self->exit_code;
#line 330 "Utility/AsyncTask.vala"
	_g_free0 (path);
#line 330 "Utility/AsyncTask.vala"
	return result;
#line 1611 "AsyncTask.c"
}

gboolean
async_task_is_running (AsyncTask* self)
{
	gboolean result;
#line 333 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 335 "Utility/AsyncTask.vala"
	result = self->status == APP_STATUS_RUNNING;
#line 335 "Utility/AsyncTask.vala"
	return result;
#line 1624 "AsyncTask.c"
}

void
async_task_stop (AsyncTask* self,
                 AppStatus status_to_update)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 340 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 342 "Utility/AsyncTask.vala"
	self->status = status_to_update;
#line 344 "Utility/AsyncTask.vala"
	tee_jee_process_helper_process_quit (self->child_pid, TRUE);
#line 346 "Utility/AsyncTask.vala"
	_tmp0_ = g_strdup_printf ("process_quit: %d", (gint) self->child_pid);
#line 346 "Utility/AsyncTask.vala"
	_tmp1_ = _tmp0_;
#line 346 "Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 346 "Utility/AsyncTask.vala"
	_g_free0 (_tmp1_);
#line 1647 "AsyncTask.c"
}

void
async_task_set_priority (AsyncTask* self)
{
#line 349 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 351 "Utility/AsyncTask.vala"
	if (self->background_mode) {
#line 352 "Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 5);
#line 1659 "AsyncTask.c"
	} else {
#line 355 "Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 0);
#line 1663 "AsyncTask.c"
	}
}

void
async_task_set_priority_value (AsyncTask* self,
                               gint prio)
{
	GPid app_pid = 0;
#line 359 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 361 "Utility/AsyncTask.vala"
	app_pid = (GPid) getpid ();
#line 362 "Utility/AsyncTask.vala"
	tee_jee_process_helper_process_set_priority (app_pid, prio);
#line 364 "Utility/AsyncTask.vala"
	if (self->status == APP_STATUS_RUNNING) {
#line 1680 "AsyncTask.c"
		GPid sub_child_pid = 0;
		gint _tmp0_ = 0;
		gint* _tmp1_;
#line 365 "Utility/AsyncTask.vala"
		tee_jee_process_helper_process_set_priority (self->child_pid, prio);
#line 368 "Utility/AsyncTask.vala"
		_tmp1_ = tee_jee_process_helper_get_process_children (self->child_pid, &_tmp0_);
#line 1688 "AsyncTask.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 368 "Utility/AsyncTask.vala"
			pid_collection = _tmp1_;
#line 368 "Utility/AsyncTask.vala"
			pid_collection_length1 = _tmp0_;
#line 368 "Utility/AsyncTask.vala"
			for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 1700 "AsyncTask.c"
				glong pid = 0L;
#line 368 "Utility/AsyncTask.vala"
				pid = (glong) pid_collection[pid_it];
#line 1704 "AsyncTask.c"
				{
#line 369 "Utility/AsyncTask.vala"
					sub_child_pid = (GPid) pid;
#line 370 "Utility/AsyncTask.vala"
					tee_jee_process_helper_process_set_priority (sub_child_pid, prio);
#line 1710 "AsyncTask.c"
				}
			}
#line 368 "Utility/AsyncTask.vala"
			pid_collection = (g_free (pid_collection), NULL);
#line 1715 "AsyncTask.c"
		}
	}
}

void
async_task_print_app_status (AsyncTask* self)
{
#line 398 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 400 "Utility/AsyncTask.vala"
	switch (self->status) {
#line 400 "Utility/AsyncTask.vala"
		case APP_STATUS_NOT_STARTED:
#line 1729 "AsyncTask.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 402 "Utility/AsyncTask.vala"
			_tmp0_ = g_strdup_printf ("status=%s", "NOT_STARTED");
#line 402 "Utility/AsyncTask.vala"
			_tmp1_ = _tmp0_;
#line 402 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp1_);
#line 402 "Utility/AsyncTask.vala"
			_g_free0 (_tmp1_);
#line 403 "Utility/AsyncTask.vala"
			break;
#line 1743 "AsyncTask.c"
		}
#line 400 "Utility/AsyncTask.vala"
		case APP_STATUS_RUNNING:
#line 1747 "AsyncTask.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 405 "Utility/AsyncTask.vala"
			_tmp2_ = g_strdup_printf ("status=%s", "RUNNING");
#line 405 "Utility/AsyncTask.vala"
			_tmp3_ = _tmp2_;
#line 405 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp3_);
#line 405 "Utility/AsyncTask.vala"
			_g_free0 (_tmp3_);
#line 406 "Utility/AsyncTask.vala"
			break;
#line 1761 "AsyncTask.c"
		}
#line 400 "Utility/AsyncTask.vala"
		case APP_STATUS_PAUSED:
#line 1765 "AsyncTask.c"
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 408 "Utility/AsyncTask.vala"
			_tmp4_ = g_strdup_printf ("status=%s", "PAUSED");
#line 408 "Utility/AsyncTask.vala"
			_tmp5_ = _tmp4_;
#line 408 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp5_);
#line 408 "Utility/AsyncTask.vala"
			_g_free0 (_tmp5_);
#line 409 "Utility/AsyncTask.vala"
			break;
#line 1779 "AsyncTask.c"
		}
#line 400 "Utility/AsyncTask.vala"
		case APP_STATUS_FINISHED:
#line 1783 "AsyncTask.c"
		{
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 411 "Utility/AsyncTask.vala"
			_tmp6_ = g_strdup_printf ("status=%s", "FINISHED");
#line 411 "Utility/AsyncTask.vala"
			_tmp7_ = _tmp6_;
#line 411 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp7_);
#line 411 "Utility/AsyncTask.vala"
			_g_free0 (_tmp7_);
#line 412 "Utility/AsyncTask.vala"
			break;
#line 1797 "AsyncTask.c"
		}
#line 400 "Utility/AsyncTask.vala"
		case APP_STATUS_CANCELLED:
#line 1801 "AsyncTask.c"
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 414 "Utility/AsyncTask.vala"
			_tmp8_ = g_strdup_printf ("status=%s", "CANCELLED");
#line 414 "Utility/AsyncTask.vala"
			_tmp9_ = _tmp8_;
#line 414 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp9_);
#line 414 "Utility/AsyncTask.vala"
			_g_free0 (_tmp9_);
#line 415 "Utility/AsyncTask.vala"
			break;
#line 1815 "AsyncTask.c"
		}
#line 400 "Utility/AsyncTask.vala"
		case APP_STATUS_PASSWORD_REQUIRED:
#line 1819 "AsyncTask.c"
		{
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 417 "Utility/AsyncTask.vala"
			_tmp10_ = g_strdup_printf ("status=%s", "PASSWORD_REQUIRED");
#line 417 "Utility/AsyncTask.vala"
			_tmp11_ = _tmp10_;
#line 417 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp11_);
#line 417 "Utility/AsyncTask.vala"
			_g_free0 (_tmp11_);
#line 418 "Utility/AsyncTask.vala"
			break;
#line 1833 "AsyncTask.c"
		}
		default:
#line 400 "Utility/AsyncTask.vala"
		break;
#line 1838 "AsyncTask.c"
	}
}

gchar*
async_task_get_stat_time_elapsed (AsyncTask* self)
{
	gchar* result;
	glong elapsed = 0L;
	GTimer* _tmp0_;
	gchar* _tmp1_;
#line 376 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 377 "Utility/AsyncTask.vala"
	_tmp0_ = self->timer;
#line 377 "Utility/AsyncTask.vala"
	elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 378 "Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_misc_format_duration (elapsed);
#line 378 "Utility/AsyncTask.vala"
	result = _tmp1_;
#line 378 "Utility/AsyncTask.vala"
	return result;
#line 1861 "AsyncTask.c"
}

gchar*
async_task_get_stat_time_remaining (AsyncTask* self)
{
	gchar* result;
#line 383 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 384 "Utility/AsyncTask.vala"
	if (self->progress > ((gdouble) 0)) {
#line 1872 "AsyncTask.c"
		glong elapsed = 0L;
		GTimer* _tmp0_;
		glong remaining = 0L;
		gchar* _tmp1_;
#line 385 "Utility/AsyncTask.vala"
		_tmp0_ = self->timer;
#line 385 "Utility/AsyncTask.vala"
		elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 386 "Utility/AsyncTask.vala"
		remaining = (glong) ((elapsed / self->progress) * (1.0 - self->progress));
#line 387 "Utility/AsyncTask.vala"
		if (remaining < ((glong) 0)) {
#line 388 "Utility/AsyncTask.vala"
			remaining = (glong) 0;
#line 1887 "AsyncTask.c"
		}
#line 390 "Utility/AsyncTask.vala"
		_tmp1_ = tee_jee_misc_format_duration (remaining);
#line 390 "Utility/AsyncTask.vala"
		result = _tmp1_;
#line 390 "Utility/AsyncTask.vala"
		return result;
#line 1895 "AsyncTask.c"
	} else {
		gchar* _tmp2_;
#line 393 "Utility/AsyncTask.vala"
		_tmp2_ = g_strdup ("???");
#line 393 "Utility/AsyncTask.vala"
		result = _tmp2_;
#line 393 "Utility/AsyncTask.vala"
		return result;
#line 1904 "AsyncTask.c"
	}
}

static void
async_task_class_init (AsyncTaskClass * klass,
                       gpointer klass_data)
{
#line 31 "Utility/AsyncTask.vala"
	async_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "Utility/AsyncTask.vala"
	g_type_class_adjust_private_offset (klass, &AsyncTask_private_offset);
#line 31 "Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask*, const gchar*)) async_task_real_parse_stdout_line;
#line 31 "Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask*, const gchar*)) async_task_real_parse_stderr_line;
#line 31 "Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask*)) async_task_real_finish_task;
#line 31 "Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_async_task_get_property;
#line 31 "Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->finalize = async_task_finalize;
#line 31 "Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY] = g_param_spec_string ("stat-time-elapsed", "stat-time-elapsed", "stat-time-elapsed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY] = g_param_spec_string ("stat-time-remaining", "stat-time-remaining", "stat-time-remaining", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL] = g_signal_new ("stdout-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL] = g_signal_new ("stderr-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL] = g_signal_new ("task-complete", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1936 "AsyncTask.c"
}

static void
async_task_instance_init (AsyncTask * self,
                          gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 31 "Utility/AsyncTask.vala"
	self->priv = async_task_get_instance_private (self);
#line 33 "Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 33 "Utility/AsyncTask.vala"
	self->priv->err_line = _tmp0_;
#line 34 "Utility/AsyncTask.vala"
	_tmp1_ = g_strdup ("");
#line 34 "Utility/AsyncTask.vala"
	self->priv->out_line = _tmp1_;
#line 39 "Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 41 "Utility/AsyncTask.vala"
	self->priv->stdout_is_open = FALSE;
#line 42 "Utility/AsyncTask.vala"
	self->priv->stderr_is_open = FALSE;
#line 48 "Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 50 "Utility/AsyncTask.vala"
	_tmp2_ = g_strdup ("");
#line 50 "Utility/AsyncTask.vala"
	self->script_file = _tmp2_;
#line 51 "Utility/AsyncTask.vala"
	_tmp3_ = g_strdup ("");
#line 51 "Utility/AsyncTask.vala"
	self->working_dir = _tmp3_;
#line 52 "Utility/AsyncTask.vala"
	_tmp4_ = g_strdup ("");
#line 52 "Utility/AsyncTask.vala"
	self->log_file = _tmp4_;
#line 54 "Utility/AsyncTask.vala"
	self->background_mode = FALSE;
#line 58 "Utility/AsyncTask.vala"
	_tmp5_ = g_strdup ("");
#line 58 "Utility/AsyncTask.vala"
	self->status_line = _tmp5_;
#line 59 "Utility/AsyncTask.vala"
	self->exit_code = 0;
#line 60 "Utility/AsyncTask.vala"
	_tmp6_ = g_strdup ("");
#line 60 "Utility/AsyncTask.vala"
	self->error_msg = _tmp6_;
#line 62 "Utility/AsyncTask.vala"
	self->progress = 0.0;
#line 63 "Utility/AsyncTask.vala"
	self->percent = 0.0;
#line 64 "Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 65 "Utility/AsyncTask.vala"
	self->prg_count_total = (gint64) 0;
#line 66 "Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 67 "Utility/AsyncTask.vala"
	self->prg_bytes_total = (gint64) 0;
#line 68 "Utility/AsyncTask.vala"
	_tmp7_ = g_strdup ("");
#line 68 "Utility/AsyncTask.vala"
	self->eta = _tmp7_;
#line 2009 "AsyncTask.c"
}

static void
async_task_finalize (GObject * obj)
{
	AsyncTask * self;
#line 31 "Utility/AsyncTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASYNC_TASK, AsyncTask);
#line 33 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 34 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 35 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 36 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_out);
#line 37 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_err);
#line 38 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->dos_log);
#line 50 "Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 51 "Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 52 "Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 58 "Utility/AsyncTask.vala"
	_g_free0 (self->status_line);
#line 60 "Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 61 "Utility/AsyncTask.vala"
	_g_timer_destroy0 (self->timer);
#line 68 "Utility/AsyncTask.vala"
	_g_free0 (self->eta);
#line 31 "Utility/AsyncTask.vala"
	G_OBJECT_CLASS (async_task_parent_class)->finalize (obj);
#line 2046 "AsyncTask.c"
}

static GType
async_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AsyncTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) async_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AsyncTask), 0, (GInstanceInitFunc) async_task_instance_init, NULL };
	GType async_task_type_id;
	async_task_type_id = g_type_register_static (G_TYPE_OBJECT, "AsyncTask", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	AsyncTask_private_offset = g_type_add_instance_private (async_task_type_id, sizeof (AsyncTaskPrivate));
	return async_task_type_id;
}

GType
async_task_get_type (void)
{
	static volatile gsize async_task_type_id__once = 0;
	if (g_once_init_enter (&async_task_type_id__once)) {
		GType async_task_type_id;
		async_task_type_id = async_task_get_type_once ();
		g_once_init_leave (&async_task_type_id__once, async_task_type_id);
	}
	return async_task_type_id__once;
}

static void
_vala_async_task_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	AsyncTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASYNC_TASK, AsyncTask);
#line 31 "Utility/AsyncTask.vala"
	switch (property_id) {
#line 31 "Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY:
#line 31 "Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_elapsed (self));
#line 31 "Utility/AsyncTask.vala"
		break;
#line 31 "Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY:
#line 31 "Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_remaining (self));
#line 31 "Utility/AsyncTask.vala"
		break;
#line 2093 "AsyncTask.c"
		default:
#line 31 "Utility/AsyncTask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "Utility/AsyncTask.vala"
		break;
#line 2099 "AsyncTask.c"
	}
}

static GType
app_status_get_type_once (void)
{
	static const GEnumValue values[] = {{APP_STATUS_NOT_STARTED, "APP_STATUS_NOT_STARTED", "not-started"}, {APP_STATUS_RUNNING, "APP_STATUS_RUNNING", "running"}, {APP_STATUS_PAUSED, "APP_STATUS_PAUSED", "paused"}, {APP_STATUS_FINISHED, "APP_STATUS_FINISHED", "finished"}, {APP_STATUS_CANCELLED, "APP_STATUS_CANCELLED", "cancelled"}, {APP_STATUS_PASSWORD_REQUIRED, "APP_STATUS_PASSWORD_REQUIRED", "password-required"}, {0, NULL, NULL}};
	GType app_status_type_id;
	app_status_type_id = g_enum_register_static ("AppStatus", values);
	return app_status_type_id;
}

GType
app_status_get_type (void)
{
	static volatile gsize app_status_type_id__once = 0;
	if (g_once_init_enter (&app_status_type_id__once)) {
		GType app_status_type_id;
		app_status_type_id = app_status_get_type_once ();
		g_once_init_leave (&app_status_type_id__once, app_status_type_id);
	}
	return app_status_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

