/* CryptTabEntry.c generated by valac 0.56.17, the Vala compiler
 * generated from CryptTabEntry.vala, do not modify */

/*
 * CryptTabEntry.vala
 *
 * Copyright 2016 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CRYPT_TAB_ENTRY (crypt_tab_entry_get_type ())
#define CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntry))
#define CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))
#define IS_CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CRYPT_TAB_ENTRY))
#define IS_CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CRYPT_TAB_ENTRY))
#define CRYPT_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))

typedef struct _CryptTabEntry CryptTabEntry;
typedef struct _CryptTabEntryClass CryptTabEntryClass;
typedef struct _CryptTabEntryPrivate CryptTabEntryPrivate;
enum  {
	CRYPT_TAB_ENTRY_0_PROPERTY,
	CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY,
	CRYPT_TAB_ENTRY_NUM_PROPERTIES
};
static GParamSpec* crypt_tab_entry_properties[CRYPT_TAB_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CryptTabEntry {
	GObject parent_instance;
	CryptTabEntryPrivate * priv;
	gboolean is_comment;
	gboolean is_empty_line;
	gchar* mapped_name;
	gchar* device_string;
	gchar* keyfile;
	gchar* options;
	gchar* line;
};

struct _CryptTabEntryClass {
	GObjectClass parent_class;
};

static gpointer crypt_tab_entry_parent_class = NULL;

VALA_EXTERN GType crypt_tab_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CryptTabEntry, g_object_unref)
VALA_EXTERN GeeArrayList* crypt_tab_entry_read_file (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_exists (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_file_read (const gchar* file_path);
VALA_EXTERN CryptTabEntry* crypt_tab_entry_new (void);
VALA_EXTERN CryptTabEntry* crypt_tab_entry_construct (GType object_type);
VALA_EXTERN gchar* crypt_tab_entry_write_file (GeeArrayList* entries,
                                   const gchar* file_path,
                                   gboolean keep_comments_and_empty_lines);
VALA_EXTERN gboolean tee_jee_file_system_file_delete (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
VALA_EXTERN void crypt_tab_entry_append_option (CryptTabEntry* self,
                                    const gchar* option);
VALA_EXTERN void crypt_tab_entry_remove_option (CryptTabEntry* self,
                                    const gchar* option);
VALA_EXTERN CryptTabEntry* crypt_tab_entry_find_entry_by_uuid (GeeArrayList* entries,
                                                   const gchar* uuid);
VALA_EXTERN gchar* crypt_tab_entry_get_device_uuid (CryptTabEntry* self);
VALA_EXTERN void crypt_tab_entry_set_device_uuid (CryptTabEntry* self,
                                      const gchar* value);
static void crypt_tab_entry_finalize (GObject * obj);
static GType crypt_tab_entry_get_type_once (void);
static void _vala_crypt_tab_entry_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_crypt_tab_entry_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 148 "CryptTabEntry.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 170 "CryptTabEntry.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 174 "CryptTabEntry.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 180 "CryptTabEntry.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 184 "CryptTabEntry.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 188 "CryptTabEntry.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 196 "CryptTabEntry.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 224 "CryptTabEntry.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 233 "CryptTabEntry.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 247 "CryptTabEntry.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 256 "CryptTabEntry.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 270 "CryptTabEntry.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 279 "CryptTabEntry.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 288 "CryptTabEntry.c"
}

GeeArrayList*
crypt_tab_entry_read_file (const gchar* file_path)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	gchar** lines = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GeeArrayList* result;
#line 59 "Utility/CryptTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 61 "Utility/CryptTabEntry.vala"
	_tmp0_ = gee_array_list_new (TYPE_CRYPT_TAB_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 61 "Utility/CryptTabEntry.vala"
	list = _tmp0_;
#line 63 "Utility/CryptTabEntry.vala"
	if (!tee_jee_file_system_file_exists (file_path)) {
#line 63 "Utility/CryptTabEntry.vala"
		result = list;
#line 63 "Utility/CryptTabEntry.vala"
		return result;
#line 319 "CryptTabEntry.c"
	}
#line 65 "Utility/CryptTabEntry.vala"
	_tmp1_ = tee_jee_file_system_file_read (file_path);
#line 65 "Utility/CryptTabEntry.vala"
	text = _tmp1_;
#line 66 "Utility/CryptTabEntry.vala"
	_tmp2_ = text;
#line 66 "Utility/CryptTabEntry.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 66 "Utility/CryptTabEntry.vala"
	lines = _tmp4_;
#line 66 "Utility/CryptTabEntry.vala"
	lines_length1 = _vala_array_length (_tmp3_);
#line 66 "Utility/CryptTabEntry.vala"
	_lines_size_ = lines_length1;
#line 67 "Utility/CryptTabEntry.vala"
	_tmp5_ = lines;
#line 67 "Utility/CryptTabEntry.vala"
	_tmp5__length1 = lines_length1;
#line 339 "CryptTabEntry.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 67 "Utility/CryptTabEntry.vala"
		line_collection = _tmp5_;
#line 67 "Utility/CryptTabEntry.vala"
		line_collection_length1 = _tmp5__length1;
#line 67 "Utility/CryptTabEntry.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 351 "CryptTabEntry.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 67 "Utility/CryptTabEntry.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 67 "Utility/CryptTabEntry.vala"
			line = _tmp6_;
#line 358 "CryptTabEntry.c"
			{
				CryptTabEntry* entry = NULL;
				CryptTabEntry* _tmp7_;
				GeeArrayList* _tmp8_;
				CryptTabEntry* _tmp9_;
				CryptTabEntry* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				CryptTabEntry* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				CryptTabEntry* _tmp20_;
#line 68 "Utility/CryptTabEntry.vala"
				_tmp7_ = crypt_tab_entry_new ();
#line 68 "Utility/CryptTabEntry.vala"
				entry = _tmp7_;
#line 69 "Utility/CryptTabEntry.vala"
				_tmp8_ = list;
#line 69 "Utility/CryptTabEntry.vala"
				_tmp9_ = entry;
#line 69 "Utility/CryptTabEntry.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 71 "Utility/CryptTabEntry.vala"
				_tmp10_ = entry;
#line 71 "Utility/CryptTabEntry.vala"
				_tmp11_ = line;
#line 71 "Utility/CryptTabEntry.vala"
				_tmp12_ = string_strip (_tmp11_);
#line 71 "Utility/CryptTabEntry.vala"
				_tmp13_ = _tmp12_;
#line 71 "Utility/CryptTabEntry.vala"
				_tmp10_->is_comment = g_str_has_prefix (_tmp13_, "#");
#line 71 "Utility/CryptTabEntry.vala"
				_g_free0 (_tmp13_);
#line 72 "Utility/CryptTabEntry.vala"
				_tmp14_ = entry;
#line 72 "Utility/CryptTabEntry.vala"
				_tmp15_ = line;
#line 72 "Utility/CryptTabEntry.vala"
				_tmp16_ = string_strip (_tmp15_);
#line 72 "Utility/CryptTabEntry.vala"
				_tmp17_ = _tmp16_;
#line 72 "Utility/CryptTabEntry.vala"
				_tmp18_ = strlen (_tmp17_);
#line 72 "Utility/CryptTabEntry.vala"
				_tmp19_ = _tmp18_;
#line 72 "Utility/CryptTabEntry.vala"
				_tmp14_->is_empty_line = _tmp19_ == 0;
#line 72 "Utility/CryptTabEntry.vala"
				_g_free0 (_tmp17_);
#line 74 "Utility/CryptTabEntry.vala"
				_tmp20_ = entry;
#line 74 "Utility/CryptTabEntry.vala"
				if (_tmp20_->is_comment) {
#line 417 "CryptTabEntry.c"
					CryptTabEntry* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
#line 75 "Utility/CryptTabEntry.vala"
					_tmp21_ = entry;
#line 75 "Utility/CryptTabEntry.vala"
					_tmp22_ = line;
#line 75 "Utility/CryptTabEntry.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 75 "Utility/CryptTabEntry.vala"
					_g_free0 (_tmp21_->line);
#line 75 "Utility/CryptTabEntry.vala"
					_tmp21_->line = _tmp23_;
#line 431 "CryptTabEntry.c"
				} else {
					CryptTabEntry* _tmp24_;
#line 77 "Utility/CryptTabEntry.vala"
					_tmp24_ = entry;
#line 77 "Utility/CryptTabEntry.vala"
					if (_tmp24_->is_empty_line) {
#line 438 "CryptTabEntry.c"
						CryptTabEntry* _tmp25_;
						gchar* _tmp26_;
#line 78 "Utility/CryptTabEntry.vala"
						_tmp25_ = entry;
#line 78 "Utility/CryptTabEntry.vala"
						_tmp26_ = g_strdup ("");
#line 78 "Utility/CryptTabEntry.vala"
						_g_free0 (_tmp25_->line);
#line 78 "Utility/CryptTabEntry.vala"
						_tmp25_->line = _tmp26_;
#line 449 "CryptTabEntry.c"
					} else {
						CryptTabEntry* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar** parts = NULL;
						const gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						gchar** _tmp33_;
						gchar** _tmp34_;
						gchar** _tmp35_;
						gint _tmp35__length1;
						gint parts_length1;
						gint _parts_size_;
						gint part_num = 0;
						gchar** _tmp36_;
						gint _tmp36__length1;
#line 81 "Utility/CryptTabEntry.vala"
						_tmp27_ = entry;
#line 81 "Utility/CryptTabEntry.vala"
						_tmp28_ = line;
#line 81 "Utility/CryptTabEntry.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 81 "Utility/CryptTabEntry.vala"
						_g_free0 (_tmp27_->line);
#line 81 "Utility/CryptTabEntry.vala"
						_tmp27_->line = _tmp29_;
#line 83 "Utility/CryptTabEntry.vala"
						_tmp30_ = line;
#line 83 "Utility/CryptTabEntry.vala"
						_tmp31_ = string_replace (_tmp30_, "\t", " ");
#line 83 "Utility/CryptTabEntry.vala"
						_tmp32_ = _tmp31_;
#line 83 "Utility/CryptTabEntry.vala"
						_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, " ", 0);
#line 83 "Utility/CryptTabEntry.vala"
						_tmp35_ = _tmp34_;
#line 83 "Utility/CryptTabEntry.vala"
						_tmp35__length1 = _vala_array_length (_tmp33_);
#line 83 "Utility/CryptTabEntry.vala"
						_g_free0 (_tmp32_);
#line 83 "Utility/CryptTabEntry.vala"
						parts = _tmp35_;
#line 83 "Utility/CryptTabEntry.vala"
						parts_length1 = _tmp35__length1;
#line 83 "Utility/CryptTabEntry.vala"
						_parts_size_ = parts_length1;
#line 84 "Utility/CryptTabEntry.vala"
						part_num = -1;
#line 85 "Utility/CryptTabEntry.vala"
						_tmp36_ = parts;
#line 85 "Utility/CryptTabEntry.vala"
						_tmp36__length1 = parts_length1;
#line 503 "CryptTabEntry.c"
						{
							gchar** part_collection = NULL;
							gint part_collection_length1 = 0;
							gint _part_collection_size_ = 0;
							gint part_it = 0;
#line 85 "Utility/CryptTabEntry.vala"
							part_collection = _tmp36_;
#line 85 "Utility/CryptTabEntry.vala"
							part_collection_length1 = _tmp36__length1;
#line 85 "Utility/CryptTabEntry.vala"
							for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 515 "CryptTabEntry.c"
								gchar* _tmp37_;
								gchar* part = NULL;
#line 85 "Utility/CryptTabEntry.vala"
								_tmp37_ = g_strdup (part_collection[part_it]);
#line 85 "Utility/CryptTabEntry.vala"
								part = _tmp37_;
#line 522 "CryptTabEntry.c"
								{
									const gchar* _tmp38_;
									gchar* _tmp39_;
									gchar* _tmp40_;
									gint _tmp41_;
									gint _tmp42_;
									gboolean _tmp43_;
									gint _tmp44_;
#line 86 "Utility/CryptTabEntry.vala"
									_tmp38_ = part;
#line 86 "Utility/CryptTabEntry.vala"
									_tmp39_ = string_strip (_tmp38_);
#line 86 "Utility/CryptTabEntry.vala"
									_tmp40_ = _tmp39_;
#line 86 "Utility/CryptTabEntry.vala"
									_tmp41_ = strlen (_tmp40_);
#line 86 "Utility/CryptTabEntry.vala"
									_tmp42_ = _tmp41_;
#line 86 "Utility/CryptTabEntry.vala"
									_tmp43_ = _tmp42_ == 0;
#line 86 "Utility/CryptTabEntry.vala"
									_g_free0 (_tmp40_);
#line 86 "Utility/CryptTabEntry.vala"
									if (_tmp43_) {
#line 86 "Utility/CryptTabEntry.vala"
										_g_free0 (part);
#line 86 "Utility/CryptTabEntry.vala"
										continue;
#line 551 "CryptTabEntry.c"
									}
#line 87 "Utility/CryptTabEntry.vala"
									part_num = part_num + 1;
#line 87 "Utility/CryptTabEntry.vala"
									_tmp44_ = part_num;
#line 87 "Utility/CryptTabEntry.vala"
									switch (_tmp44_) {
#line 87 "Utility/CryptTabEntry.vala"
										case 0:
#line 561 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp45_;
											const gchar* _tmp46_;
											gchar* _tmp47_;
#line 89 "Utility/CryptTabEntry.vala"
											_tmp45_ = entry;
#line 89 "Utility/CryptTabEntry.vala"
											_tmp46_ = part;
#line 89 "Utility/CryptTabEntry.vala"
											_tmp47_ = string_strip (_tmp46_);
#line 89 "Utility/CryptTabEntry.vala"
											_g_free0 (_tmp45_->mapped_name);
#line 89 "Utility/CryptTabEntry.vala"
											_tmp45_->mapped_name = _tmp47_;
#line 90 "Utility/CryptTabEntry.vala"
											break;
#line 578 "CryptTabEntry.c"
										}
#line 87 "Utility/CryptTabEntry.vala"
										case 1:
#line 582 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp48_;
											const gchar* _tmp49_;
											gchar* _tmp50_;
#line 92 "Utility/CryptTabEntry.vala"
											_tmp48_ = entry;
#line 92 "Utility/CryptTabEntry.vala"
											_tmp49_ = part;
#line 92 "Utility/CryptTabEntry.vala"
											_tmp50_ = string_strip (_tmp49_);
#line 92 "Utility/CryptTabEntry.vala"
											_g_free0 (_tmp48_->device_string);
#line 92 "Utility/CryptTabEntry.vala"
											_tmp48_->device_string = _tmp50_;
#line 93 "Utility/CryptTabEntry.vala"
											break;
#line 599 "CryptTabEntry.c"
										}
#line 87 "Utility/CryptTabEntry.vala"
										case 2:
#line 603 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp51_;
											const gchar* _tmp52_;
											gchar* _tmp53_;
#line 95 "Utility/CryptTabEntry.vala"
											_tmp51_ = entry;
#line 95 "Utility/CryptTabEntry.vala"
											_tmp52_ = part;
#line 95 "Utility/CryptTabEntry.vala"
											_tmp53_ = string_strip (_tmp52_);
#line 95 "Utility/CryptTabEntry.vala"
											_g_free0 (_tmp51_->keyfile);
#line 95 "Utility/CryptTabEntry.vala"
											_tmp51_->keyfile = _tmp53_;
#line 96 "Utility/CryptTabEntry.vala"
											break;
#line 620 "CryptTabEntry.c"
										}
#line 87 "Utility/CryptTabEntry.vala"
										case 3:
#line 624 "CryptTabEntry.c"
										{
											CryptTabEntry* _tmp54_;
											const gchar* _tmp55_;
											gchar* _tmp56_;
#line 98 "Utility/CryptTabEntry.vala"
											_tmp54_ = entry;
#line 98 "Utility/CryptTabEntry.vala"
											_tmp55_ = part;
#line 98 "Utility/CryptTabEntry.vala"
											_tmp56_ = string_strip (_tmp55_);
#line 98 "Utility/CryptTabEntry.vala"
											_g_free0 (_tmp54_->options);
#line 98 "Utility/CryptTabEntry.vala"
											_tmp54_->options = _tmp56_;
#line 99 "Utility/CryptTabEntry.vala"
											break;
#line 641 "CryptTabEntry.c"
										}
										default:
#line 87 "Utility/CryptTabEntry.vala"
										break;
#line 646 "CryptTabEntry.c"
									}
#line 85 "Utility/CryptTabEntry.vala"
									_g_free0 (part);
#line 650 "CryptTabEntry.c"
								}
							}
						}
#line 77 "Utility/CryptTabEntry.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 656 "CryptTabEntry.c"
					}
				}
#line 67 "Utility/CryptTabEntry.vala"
				_g_object_unref0 (entry);
#line 67 "Utility/CryptTabEntry.vala"
				_g_free0 (line);
#line 663 "CryptTabEntry.c"
			}
		}
	}
#line 105 "Utility/CryptTabEntry.vala"
	result = list;
#line 105 "Utility/CryptTabEntry.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 105 "Utility/CryptTabEntry.vala"
	_g_free0 (text);
#line 105 "Utility/CryptTabEntry.vala"
	return result;
#line 675 "CryptTabEntry.c"
}

gchar*
crypt_tab_entry_write_file (GeeArrayList* entries,
                            const gchar* file_path,
                            gboolean keep_comments_and_empty_lines)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp29_;
	gchar* result;
#line 108 "Utility/CryptTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 108 "Utility/CryptTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 110 "Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 110 "Utility/CryptTabEntry.vala"
	text = _tmp0_;
#line 695 "CryptTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		gint _entry_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _entry_index = 0;
#line 111 "Utility/CryptTabEntry.vala"
		_entry_list = entries;
#line 111 "Utility/CryptTabEntry.vala"
		_tmp1_ = _entry_list;
#line 111 "Utility/CryptTabEntry.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 111 "Utility/CryptTabEntry.vala"
		_tmp3_ = _tmp2_;
#line 111 "Utility/CryptTabEntry.vala"
		_entry_size = _tmp3_;
#line 111 "Utility/CryptTabEntry.vala"
		_entry_index = -1;
#line 111 "Utility/CryptTabEntry.vala"
		while (TRUE) {
#line 717 "CryptTabEntry.c"
			gint _tmp4_;
			gint _tmp5_;
			CryptTabEntry* entry = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			CryptTabEntry* _tmp9_;
#line 111 "Utility/CryptTabEntry.vala"
			_entry_index = _entry_index + 1;
#line 111 "Utility/CryptTabEntry.vala"
			_tmp4_ = _entry_index;
#line 111 "Utility/CryptTabEntry.vala"
			_tmp5_ = _entry_size;
#line 111 "Utility/CryptTabEntry.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 111 "Utility/CryptTabEntry.vala"
				break;
#line 735 "CryptTabEntry.c"
			}
#line 111 "Utility/CryptTabEntry.vala"
			_tmp6_ = _entry_list;
#line 111 "Utility/CryptTabEntry.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _entry_index);
#line 111 "Utility/CryptTabEntry.vala"
			entry = (CryptTabEntry*) _tmp7_;
#line 112 "Utility/CryptTabEntry.vala"
			_tmp9_ = entry;
#line 112 "Utility/CryptTabEntry.vala"
			if (_tmp9_->is_comment) {
#line 112 "Utility/CryptTabEntry.vala"
				_tmp8_ = TRUE;
#line 749 "CryptTabEntry.c"
			} else {
				CryptTabEntry* _tmp10_;
#line 112 "Utility/CryptTabEntry.vala"
				_tmp10_ = entry;
#line 112 "Utility/CryptTabEntry.vala"
				_tmp8_ = _tmp10_->is_empty_line;
#line 756 "CryptTabEntry.c"
			}
#line 112 "Utility/CryptTabEntry.vala"
			if (_tmp8_) {
#line 113 "Utility/CryptTabEntry.vala"
				if (keep_comments_and_empty_lines) {
#line 762 "CryptTabEntry.c"
					const gchar* _tmp11_;
					CryptTabEntry* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
#line 114 "Utility/CryptTabEntry.vala"
					_tmp11_ = text;
#line 114 "Utility/CryptTabEntry.vala"
					_tmp12_ = entry;
#line 114 "Utility/CryptTabEntry.vala"
					_tmp13_ = _tmp12_->line;
#line 114 "Utility/CryptTabEntry.vala"
					_tmp14_ = g_strdup_printf ("%s\n", _tmp13_);
#line 114 "Utility/CryptTabEntry.vala"
					_tmp15_ = _tmp14_;
#line 114 "Utility/CryptTabEntry.vala"
					_tmp16_ = g_strconcat (_tmp11_, _tmp15_, NULL);
#line 114 "Utility/CryptTabEntry.vala"
					_g_free0 (text);
#line 114 "Utility/CryptTabEntry.vala"
					text = _tmp16_;
#line 114 "Utility/CryptTabEntry.vala"
					_g_free0 (_tmp15_);
#line 787 "CryptTabEntry.c"
				}
			} else {
				const gchar* _tmp17_;
				CryptTabEntry* _tmp18_;
				const gchar* _tmp19_;
				CryptTabEntry* _tmp20_;
				const gchar* _tmp21_;
				CryptTabEntry* _tmp22_;
				const gchar* _tmp23_;
				CryptTabEntry* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp17_ = text;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp18_ = entry;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp19_ = _tmp18_->mapped_name;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp20_ = entry;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp21_ = _tmp20_->device_string;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp22_ = entry;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp23_ = _tmp22_->keyfile;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp24_ = entry;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp25_ = _tmp24_->options;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp26_ = g_strdup_printf ("%s\t%s\t%s\t%s\n", _tmp19_, _tmp21_, _tmp23_, _tmp25_);
#line 118 "Utility/CryptTabEntry.vala"
				_tmp27_ = _tmp26_;
#line 118 "Utility/CryptTabEntry.vala"
				_tmp28_ = g_strconcat (_tmp17_, _tmp27_, NULL);
#line 118 "Utility/CryptTabEntry.vala"
				_g_free0 (text);
#line 118 "Utility/CryptTabEntry.vala"
				text = _tmp28_;
#line 118 "Utility/CryptTabEntry.vala"
				_g_free0 (_tmp27_);
#line 832 "CryptTabEntry.c"
			}
#line 111 "Utility/CryptTabEntry.vala"
			_g_object_unref0 (entry);
#line 836 "CryptTabEntry.c"
		}
	}
#line 124 "Utility/CryptTabEntry.vala"
	if (tee_jee_file_system_file_exists (file_path)) {
#line 125 "Utility/CryptTabEntry.vala"
		tee_jee_file_system_file_delete (file_path);
#line 843 "CryptTabEntry.c"
	}
#line 128 "Utility/CryptTabEntry.vala"
	_tmp29_ = text;
#line 128 "Utility/CryptTabEntry.vala"
	tee_jee_file_system_file_write (file_path, _tmp29_);
#line 130 "Utility/CryptTabEntry.vala"
	result = text;
#line 130 "Utility/CryptTabEntry.vala"
	return result;
#line 853 "CryptTabEntry.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 872 "CryptTabEntry.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 899 "CryptTabEntry.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 905 "CryptTabEntry.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 911 "CryptTabEntry.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 915 "CryptTabEntry.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 923 "CryptTabEntry.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 927 "CryptTabEntry.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 939 "CryptTabEntry.c"
}

void
crypt_tab_entry_append_option (CryptTabEntry* self,
                               const gchar* option)
{
	const gchar* _tmp0_;
	const gchar* _tmp5_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 133 "Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 133 "Utility/CryptTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 135 "Utility/CryptTabEntry.vala"
	_tmp0_ = self->options;
#line 135 "Utility/CryptTabEntry.vala"
	if (!string_contains (_tmp0_, option)) {
#line 958 "CryptTabEntry.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 136 "Utility/CryptTabEntry.vala"
		_tmp1_ = self->options;
#line 136 "Utility/CryptTabEntry.vala"
		_tmp2_ = g_strdup_printf (",%s", option);
#line 136 "Utility/CryptTabEntry.vala"
		_tmp3_ = _tmp2_;
#line 136 "Utility/CryptTabEntry.vala"
		_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 136 "Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 136 "Utility/CryptTabEntry.vala"
		self->options = _tmp4_;
#line 136 "Utility/CryptTabEntry.vala"
		_g_free0 (_tmp3_);
#line 977 "CryptTabEntry.c"
	}
#line 139 "Utility/CryptTabEntry.vala"
	_tmp5_ = self->options;
#line 139 "Utility/CryptTabEntry.vala"
	if (g_str_has_prefix (_tmp5_, ",")) {
#line 983 "CryptTabEntry.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gchar* _tmp10_;
#line 140 "Utility/CryptTabEntry.vala"
		_tmp6_ = self->options;
#line 140 "Utility/CryptTabEntry.vala"
		_tmp7_ = self->options;
#line 140 "Utility/CryptTabEntry.vala"
		_tmp8_ = strlen (_tmp7_);
#line 140 "Utility/CryptTabEntry.vala"
		_tmp9_ = _tmp8_;
#line 140 "Utility/CryptTabEntry.vala"
		_tmp10_ = string_slice (_tmp6_, (glong) 1, (glong) _tmp9_);
#line 140 "Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 140 "Utility/CryptTabEntry.vala"
		self->options = _tmp10_;
#line 1003 "CryptTabEntry.c"
	}
#line 143 "Utility/CryptTabEntry.vala"
	_tmp11_ = self->options;
#line 143 "Utility/CryptTabEntry.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 143 "Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 143 "Utility/CryptTabEntry.vala"
	self->options = _tmp12_;
#line 1013 "CryptTabEntry.c"
}

void
crypt_tab_entry_remove_option (CryptTabEntry* self,
                               const gchar* option)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp10_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
#line 146 "Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 146 "Utility/CryptTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 148 "Utility/CryptTabEntry.vala"
	_tmp0_ = self->options;
#line 148 "Utility/CryptTabEntry.vala"
	_tmp1_ = string_replace (_tmp0_, option, "");
#line 148 "Utility/CryptTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 148 "Utility/CryptTabEntry.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 148 "Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 148 "Utility/CryptTabEntry.vala"
	self->options = _tmp3_;
#line 148 "Utility/CryptTabEntry.vala"
	_g_free0 (_tmp2_);
#line 150 "Utility/CryptTabEntry.vala"
	_tmp4_ = self->options;
#line 150 "Utility/CryptTabEntry.vala"
	if (g_str_has_prefix (_tmp4_, ",")) {
#line 1050 "CryptTabEntry.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
#line 151 "Utility/CryptTabEntry.vala"
		_tmp5_ = self->options;
#line 151 "Utility/CryptTabEntry.vala"
		_tmp6_ = self->options;
#line 151 "Utility/CryptTabEntry.vala"
		_tmp7_ = strlen (_tmp6_);
#line 151 "Utility/CryptTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 151 "Utility/CryptTabEntry.vala"
		_tmp9_ = string_slice (_tmp5_, (glong) 1, (glong) _tmp8_);
#line 151 "Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 151 "Utility/CryptTabEntry.vala"
		self->options = _tmp9_;
#line 1070 "CryptTabEntry.c"
	}
#line 154 "Utility/CryptTabEntry.vala"
	_tmp10_ = self->options;
#line 154 "Utility/CryptTabEntry.vala"
	if (g_str_has_suffix (_tmp10_, ",")) {
#line 1076 "CryptTabEntry.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gchar* _tmp15_;
#line 155 "Utility/CryptTabEntry.vala"
		_tmp11_ = self->options;
#line 155 "Utility/CryptTabEntry.vala"
		_tmp12_ = self->options;
#line 155 "Utility/CryptTabEntry.vala"
		_tmp13_ = strlen (_tmp12_);
#line 155 "Utility/CryptTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 155 "Utility/CryptTabEntry.vala"
		_tmp15_ = string_slice (_tmp11_, (glong) 0, (glong) (_tmp14_ - 1));
#line 155 "Utility/CryptTabEntry.vala"
		_g_free0 (self->options);
#line 155 "Utility/CryptTabEntry.vala"
		self->options = _tmp15_;
#line 1096 "CryptTabEntry.c"
	}
#line 158 "Utility/CryptTabEntry.vala"
	_tmp16_ = self->options;
#line 158 "Utility/CryptTabEntry.vala"
	_tmp17_ = string_strip (_tmp16_);
#line 158 "Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 158 "Utility/CryptTabEntry.vala"
	self->options = _tmp17_;
#line 1106 "CryptTabEntry.c"
}

CryptTabEntry*
crypt_tab_entry_find_entry_by_uuid (GeeArrayList* entries,
                                    const gchar* uuid)
{
	CryptTabEntry* result;
#line 161 "Utility/CryptTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 161 "Utility/CryptTabEntry.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1118 "CryptTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		gint _entry_size = 0;
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _entry_index = 0;
#line 164 "Utility/CryptTabEntry.vala"
		_entry_list = entries;
#line 164 "Utility/CryptTabEntry.vala"
		_tmp0_ = _entry_list;
#line 164 "Utility/CryptTabEntry.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 164 "Utility/CryptTabEntry.vala"
		_tmp2_ = _tmp1_;
#line 164 "Utility/CryptTabEntry.vala"
		_entry_size = _tmp2_;
#line 164 "Utility/CryptTabEntry.vala"
		_entry_index = -1;
#line 164 "Utility/CryptTabEntry.vala"
		while (TRUE) {
#line 1140 "CryptTabEntry.c"
			gint _tmp3_;
			gint _tmp4_;
			CryptTabEntry* entry = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			CryptTabEntry* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gboolean _tmp11_;
#line 164 "Utility/CryptTabEntry.vala"
			_entry_index = _entry_index + 1;
#line 164 "Utility/CryptTabEntry.vala"
			_tmp3_ = _entry_index;
#line 164 "Utility/CryptTabEntry.vala"
			_tmp4_ = _entry_size;
#line 164 "Utility/CryptTabEntry.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 164 "Utility/CryptTabEntry.vala"
				break;
#line 1161 "CryptTabEntry.c"
			}
#line 164 "Utility/CryptTabEntry.vala"
			_tmp5_ = _entry_list;
#line 164 "Utility/CryptTabEntry.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _entry_index);
#line 164 "Utility/CryptTabEntry.vala"
			entry = (CryptTabEntry*) _tmp6_;
#line 165 "Utility/CryptTabEntry.vala"
			_tmp7_ = entry;
#line 165 "Utility/CryptTabEntry.vala"
			_tmp8_ = crypt_tab_entry_get_device_uuid (_tmp7_);
#line 165 "Utility/CryptTabEntry.vala"
			_tmp9_ = _tmp8_;
#line 165 "Utility/CryptTabEntry.vala"
			_tmp10_ = _tmp9_;
#line 165 "Utility/CryptTabEntry.vala"
			_tmp11_ = g_strcmp0 (_tmp10_, uuid) == 0;
#line 165 "Utility/CryptTabEntry.vala"
			_g_free0 (_tmp10_);
#line 165 "Utility/CryptTabEntry.vala"
			if (_tmp11_) {
#line 166 "Utility/CryptTabEntry.vala"
				result = entry;
#line 166 "Utility/CryptTabEntry.vala"
				return result;
#line 1187 "CryptTabEntry.c"
			}
#line 164 "Utility/CryptTabEntry.vala"
			_g_object_unref0 (entry);
#line 1191 "CryptTabEntry.c"
		}
	}
#line 170 "Utility/CryptTabEntry.vala"
	result = NULL;
#line 170 "Utility/CryptTabEntry.vala"
	return result;
#line 1198 "CryptTabEntry.c"
}

CryptTabEntry*
crypt_tab_entry_construct (GType object_type)
{
	CryptTabEntry * self = NULL;
#line 33 "Utility/CryptTabEntry.vala"
	self = (CryptTabEntry*) g_object_new (object_type, NULL);
#line 33 "Utility/CryptTabEntry.vala"
	return self;
#line 1209 "CryptTabEntry.c"
}

CryptTabEntry*
crypt_tab_entry_new (void)
{
#line 33 "Utility/CryptTabEntry.vala"
	return crypt_tab_entry_construct (TYPE_CRYPT_TAB_ENTRY);
#line 1217 "CryptTabEntry.c"
}

gchar*
crypt_tab_entry_get_device_uuid (CryptTabEntry* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 46 "Utility/CryptTabEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "Utility/CryptTabEntry.vala"
	_tmp0_ = self->device_string;
#line 47 "Utility/CryptTabEntry.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 47 "Utility/CryptTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 47 "Utility/CryptTabEntry.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "uuid=");
#line 47 "Utility/CryptTabEntry.vala"
	_g_free0 (_tmp2_);
#line 47 "Utility/CryptTabEntry.vala"
	if (_tmp3_) {
#line 1242 "CryptTabEntry.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 48 "Utility/CryptTabEntry.vala"
		_tmp4_ = self->device_string;
#line 48 "Utility/CryptTabEntry.vala"
		_tmp5_ = string_replace (_tmp4_, "\"", "");
#line 48 "Utility/CryptTabEntry.vala"
		_tmp6_ = _tmp5_;
#line 48 "Utility/CryptTabEntry.vala"
		_tmp7_ = string_replace (_tmp6_, "'", "");
#line 48 "Utility/CryptTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 48 "Utility/CryptTabEntry.vala"
		_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "=", 0);
#line 48 "Utility/CryptTabEntry.vala"
		_tmp11_ = _tmp10_;
#line 48 "Utility/CryptTabEntry.vala"
		_tmp11__length1 = _vala_array_length (_tmp9_);
#line 48 "Utility/CryptTabEntry.vala"
		_tmp12_ = _tmp11_[1];
#line 48 "Utility/CryptTabEntry.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 48 "Utility/CryptTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 48 "Utility/CryptTabEntry.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 48 "Utility/CryptTabEntry.vala"
		_g_free0 (_tmp8_);
#line 48 "Utility/CryptTabEntry.vala"
		_g_free0 (_tmp6_);
#line 48 "Utility/CryptTabEntry.vala"
		result = _tmp14_;
#line 48 "Utility/CryptTabEntry.vala"
		return result;
#line 1287 "CryptTabEntry.c"
	} else {
		gchar* _tmp15_;
#line 51 "Utility/CryptTabEntry.vala"
		_tmp15_ = g_strdup ("");
#line 51 "Utility/CryptTabEntry.vala"
		result = _tmp15_;
#line 51 "Utility/CryptTabEntry.vala"
		return result;
#line 1296 "CryptTabEntry.c"
	}
}

void
crypt_tab_entry_set_device_uuid (CryptTabEntry* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
#line 54 "Utility/CryptTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 55 "Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup_printf ("UUID=%s", value);
#line 55 "Utility/CryptTabEntry.vala"
	_g_free0 (self->device_string);
#line 55 "Utility/CryptTabEntry.vala"
	self->device_string = _tmp0_;
#line 54 "Utility/CryptTabEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, crypt_tab_entry_properties[CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY]);
#line 1315 "CryptTabEntry.c"
}

static void
crypt_tab_entry_class_init (CryptTabEntryClass * klass,
                            gpointer klass_data)
{
#line 33 "Utility/CryptTabEntry.vala"
	crypt_tab_entry_parent_class = g_type_class_peek_parent (klass);
#line 33 "Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_crypt_tab_entry_get_property;
#line 33 "Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_crypt_tab_entry_set_property;
#line 33 "Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = crypt_tab_entry_finalize;
#line 33 "Utility/CryptTabEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY, crypt_tab_entry_properties[CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY] = g_param_spec_string ("device-uuid", "device-uuid", "device-uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1332 "CryptTabEntry.c"
}

static void
crypt_tab_entry_instance_init (CryptTabEntry * self,
                               gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 35 "Utility/CryptTabEntry.vala"
	self->is_comment = FALSE;
#line 36 "Utility/CryptTabEntry.vala"
	self->is_empty_line = FALSE;
#line 39 "Utility/CryptTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 39 "Utility/CryptTabEntry.vala"
	self->mapped_name = _tmp0_;
#line 40 "Utility/CryptTabEntry.vala"
	_tmp1_ = g_strdup ("");
#line 40 "Utility/CryptTabEntry.vala"
	self->device_string = _tmp1_;
#line 41 "Utility/CryptTabEntry.vala"
	_tmp2_ = g_strdup ("none");
#line 41 "Utility/CryptTabEntry.vala"
	self->keyfile = _tmp2_;
#line 42 "Utility/CryptTabEntry.vala"
	_tmp3_ = g_strdup ("luks,nofail");
#line 42 "Utility/CryptTabEntry.vala"
	self->options = _tmp3_;
#line 43 "Utility/CryptTabEntry.vala"
	_tmp4_ = g_strdup ("");
#line 43 "Utility/CryptTabEntry.vala"
	self->line = _tmp4_;
#line 1368 "CryptTabEntry.c"
}

static void
crypt_tab_entry_finalize (GObject * obj)
{
	CryptTabEntry * self;
#line 33 "Utility/CryptTabEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 39 "Utility/CryptTabEntry.vala"
	_g_free0 (self->mapped_name);
#line 40 "Utility/CryptTabEntry.vala"
	_g_free0 (self->device_string);
#line 41 "Utility/CryptTabEntry.vala"
	_g_free0 (self->keyfile);
#line 42 "Utility/CryptTabEntry.vala"
	_g_free0 (self->options);
#line 43 "Utility/CryptTabEntry.vala"
	_g_free0 (self->line);
#line 33 "Utility/CryptTabEntry.vala"
	G_OBJECT_CLASS (crypt_tab_entry_parent_class)->finalize (obj);
#line 1389 "CryptTabEntry.c"
}

static GType
crypt_tab_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CryptTabEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crypt_tab_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CryptTabEntry), 0, (GInstanceInitFunc) crypt_tab_entry_instance_init, NULL };
	GType crypt_tab_entry_type_id;
	crypt_tab_entry_type_id = g_type_register_static (G_TYPE_OBJECT, "CryptTabEntry", &g_define_type_info, 0);
	return crypt_tab_entry_type_id;
}

GType
crypt_tab_entry_get_type (void)
{
	static volatile gsize crypt_tab_entry_type_id__once = 0;
	if (g_once_init_enter (&crypt_tab_entry_type_id__once)) {
		GType crypt_tab_entry_type_id;
		crypt_tab_entry_type_id = crypt_tab_entry_get_type_once ();
		g_once_init_leave (&crypt_tab_entry_type_id__once, crypt_tab_entry_type_id);
	}
	return crypt_tab_entry_type_id__once;
}

static void
_vala_crypt_tab_entry_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	CryptTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 33 "Utility/CryptTabEntry.vala"
	switch (property_id) {
#line 33 "Utility/CryptTabEntry.vala"
		case CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 33 "Utility/CryptTabEntry.vala"
		g_value_take_string (value, crypt_tab_entry_get_device_uuid (self));
#line 33 "Utility/CryptTabEntry.vala"
		break;
#line 1429 "CryptTabEntry.c"
		default:
#line 33 "Utility/CryptTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "Utility/CryptTabEntry.vala"
		break;
#line 1435 "CryptTabEntry.c"
	}
}

static void
_vala_crypt_tab_entry_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	CryptTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CRYPT_TAB_ENTRY, CryptTabEntry);
#line 33 "Utility/CryptTabEntry.vala"
	switch (property_id) {
#line 33 "Utility/CryptTabEntry.vala"
		case CRYPT_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 33 "Utility/CryptTabEntry.vala"
		crypt_tab_entry_set_device_uuid (self, g_value_get_string (value));
#line 33 "Utility/CryptTabEntry.vala"
		break;
#line 1455 "CryptTabEntry.c"
		default:
#line 33 "Utility/CryptTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "Utility/CryptTabEntry.vala"
		break;
#line 1461 "CryptTabEntry.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

