/* TerminalWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from TerminalWindow.vala, do not modify */

/*
 * TerminalWindow.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <vte/vte.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TERMINAL_WINDOW (terminal_window_get_type ())
#define TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TERMINAL_WINDOW, TerminalWindow))
#define TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TERMINAL_WINDOW, TerminalWindowClass))
#define IS_TERMINAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TERMINAL_WINDOW))
#define IS_TERMINAL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TERMINAL_WINDOW))
#define TERMINAL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TERMINAL_WINDOW, TerminalWindowClass))

typedef struct _TerminalWindow TerminalWindow;
typedef struct _TerminalWindowClass TerminalWindowClass;
typedef struct _TerminalWindowPrivate TerminalWindowPrivate;
enum  {
	TERMINAL_WINDOW_0_PROPERTY,
	TERMINAL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* terminal_window_properties[TERMINAL_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TerminalWindow {
	GtkWindow parent_instance;
	TerminalWindowPrivate * priv;
	gboolean is_running;
};

struct _TerminalWindowClass {
	GtkWindowClass parent_class;
};

struct _TerminalWindowPrivate {
	GtkBox* vbox_main;
	VteTerminal* term;
	gint def_width;
	gint def_height;
	GPid child_pid;
	GtkWindow* parent_win;
};

static gint TerminalWindow_private_offset;
static gpointer terminal_window_parent_class = NULL;
VALA_EXTERN gchar* tee_jee_process_helper_TEMP_DIR;

VALA_EXTERN GType terminal_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalWindow, g_object_unref)
VALA_EXTERN TerminalWindow* terminal_window_new_with_parent (GtkWindow* parent);
VALA_EXTERN TerminalWindow* terminal_window_construct_with_parent (GType object_type,
                                                       GtkWindow* parent);
static gboolean __lambda15_ (TerminalWindow* self);
static gboolean ___lambda15__gtk_widget_delete_event (GtkWidget* _sender,
                                               GdkEventAny* event,
                                               gpointer self);
VALA_EXTERN void terminal_window_init_window (TerminalWindow* self);
VALA_EXTERN GdkPixbuf* icon_manager_lookup (const gchar* icon_name,
                                gint icon_size,
                                gboolean symbolic,
                                gboolean use_hardcoded,
                                gint scale);
VALA_EXTERN void terminal_window_start_shell (TerminalWindow* self);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
VALA_EXTERN void terminal_window_execute_script (TerminalWindow* self,
                                     const gchar* script_path,
                                     gboolean wait);
VALA_EXTERN void terminal_window_script_exit (TerminalWindow* self,
                                  gint status);
static void _terminal_window_script_exit_vte_terminal_child_exited (VteTerminal* _sender,
                                                             gint status,
                                                             gpointer self);
VALA_EXTERN void tee_jee_system_sleep (gint milliseconds);
VALA_EXTERN void tee_jee_gtk_helper_gtk_do_events (void);
VALA_EXTERN TerminalWindow* terminal_window_new (void);
VALA_EXTERN TerminalWindow* terminal_window_construct (GType object_type);
static void terminal_window_finalize (GObject * obj);
static GType terminal_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
terminal_window_get_instance_private (TerminalWindow* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "Utility/Gtk/TerminalWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 149 "TerminalWindow.c"
}

static gboolean
__lambda15_ (TerminalWindow* self)
{
	gboolean result;
#line 62 "Utility/Gtk/TerminalWindow.vala"
	result = TRUE;
#line 62 "Utility/Gtk/TerminalWindow.vala"
	return result;
#line 160 "TerminalWindow.c"
}

static gboolean
___lambda15__gtk_widget_delete_event (GtkWidget* _sender,
                                      GdkEventAny* event,
                                      gpointer self)
{
	gboolean result;
	result = __lambda15_ ((TerminalWindow*) self);
#line 60 "Utility/Gtk/TerminalWindow.vala"
	return result;
#line 172 "TerminalWindow.c"
}

TerminalWindow*
terminal_window_construct_with_parent (GType object_type,
                                       GtkWindow* parent)
{
	TerminalWindow * self = NULL;
#line 50 "Utility/Gtk/TerminalWindow.vala"
	self = (TerminalWindow*) g_object_new (object_type, NULL);
#line 52 "Utility/Gtk/TerminalWindow.vala"
	if (parent != NULL) {
#line 184 "TerminalWindow.c"
		GtkWindow* _tmp0_;
#line 53 "Utility/Gtk/TerminalWindow.vala"
		gtk_window_set_transient_for ((GtkWindow*) self, parent);
#line 54 "Utility/Gtk/TerminalWindow.vala"
		_tmp0_ = _g_object_ref0 (parent);
#line 54 "Utility/Gtk/TerminalWindow.vala"
		_g_object_unref0 (self->priv->parent_win);
#line 54 "Utility/Gtk/TerminalWindow.vala"
		self->priv->parent_win = _tmp0_;
#line 194 "TerminalWindow.c"
	}
#line 57 "Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 58 "Utility/Gtk/TerminalWindow.vala"
	gtk_window_fullscreen ((GtkWindow*) self);
#line 60 "Utility/Gtk/TerminalWindow.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) ___lambda15__gtk_widget_delete_event, self, 0);
#line 65 "Utility/Gtk/TerminalWindow.vala"
	terminal_window_init_window (self);
#line 50 "Utility/Gtk/TerminalWindow.vala"
	return self;
#line 206 "TerminalWindow.c"
}

TerminalWindow*
terminal_window_new_with_parent (GtkWindow* parent)
{
#line 50 "Utility/Gtk/TerminalWindow.vala"
	return terminal_window_construct_with_parent (TYPE_TERMINAL_WINDOW, parent);
#line 214 "TerminalWindow.c"
}

void
terminal_window_init_window (TerminalWindow* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	VteTerminal* _tmp5_;
	VteTerminal* _tmp6_;
	GtkBox* _tmp7_;
	VteTerminal* _tmp8_;
	VteTerminal* _tmp9_;
	VteTerminal* _tmp10_;
	VteTerminal* _tmp11_;
	VteTerminal* _tmp12_;
	VteTerminal* _tmp13_;
	VteTerminal* _tmp14_;
	GdkRGBA color = {0};
	VteTerminal* _tmp15_;
	GdkRGBA _tmp16_;
	VteTerminal* _tmp17_;
	GdkRGBA _tmp18_;
	VteTerminal* _tmp19_;
#line 68 "Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 70 "Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, "");
#line 71 "Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = icon_manager_lookup ("timeshift", 16, FALSE, FALSE, 1);
#line 71 "Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = _tmp0_;
#line 71 "Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_icon ((GtkWindow*) self, _tmp1_);
#line 71 "Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 72 "Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
#line 73 "Utility/Gtk/TerminalWindow.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 77 "Utility/Gtk/TerminalWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 77 "Utility/Gtk/TerminalWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 77 "Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->vbox_main);
#line 77 "Utility/Gtk/TerminalWindow.vala"
	self->priv->vbox_main = _tmp2_;
#line 78 "Utility/Gtk/TerminalWindow.vala"
	_tmp3_ = self->priv->vbox_main;
#line 78 "Utility/Gtk/TerminalWindow.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp3_, self->priv->def_width, self->priv->def_height);
#line 79 "Utility/Gtk/TerminalWindow.vala"
	_tmp4_ = self->priv->vbox_main;
#line 79 "Utility/Gtk/TerminalWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 83 "Utility/Gtk/TerminalWindow.vala"
	_tmp5_ = (VteTerminal*) vte_terminal_new ();
#line 83 "Utility/Gtk/TerminalWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 83 "Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->term);
#line 83 "Utility/Gtk/TerminalWindow.vala"
	self->priv->term = _tmp5_;
#line 84 "Utility/Gtk/TerminalWindow.vala"
	_tmp6_ = self->priv->term;
#line 84 "Utility/Gtk/TerminalWindow.vala"
	g_object_set ((GtkWidget*) _tmp6_, "expand", TRUE, NULL);
#line 85 "Utility/Gtk/TerminalWindow.vala"
	_tmp7_ = self->priv->vbox_main;
#line 85 "Utility/Gtk/TerminalWindow.vala"
	_tmp8_ = self->priv->term;
#line 85 "Utility/Gtk/TerminalWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 87 "Utility/Gtk/TerminalWindow.vala"
	_tmp9_ = self->priv->term;
#line 87 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_input_enabled (_tmp9_, TRUE);
#line 88 "Utility/Gtk/TerminalWindow.vala"
	_tmp10_ = self->priv->term;
#line 88 "Utility/Gtk/TerminalWindow.vala"
	g_object_set (_tmp10_, "backspace-binding", VTE_ERASE_AUTO, NULL);
#line 89 "Utility/Gtk/TerminalWindow.vala"
	_tmp11_ = self->priv->term;
#line 89 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_cursor_blink_mode (_tmp11_, VTE_CURSOR_BLINK_SYSTEM);
#line 90 "Utility/Gtk/TerminalWindow.vala"
	_tmp12_ = self->priv->term;
#line 90 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_cursor_shape (_tmp12_, VTE_CURSOR_SHAPE_UNDERLINE);
#line 93 "Utility/Gtk/TerminalWindow.vala"
	_tmp13_ = self->priv->term;
#line 93 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_scroll_on_keystroke (_tmp13_, TRUE);
#line 94 "Utility/Gtk/TerminalWindow.vala"
	_tmp14_ = self->priv->term;
#line 94 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_scroll_on_output (_tmp14_, TRUE);
#line 98 "Utility/Gtk/TerminalWindow.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 99 "Utility/Gtk/TerminalWindow.vala"
	gdk_rgba_parse (&color, "#FFFFFF");
#line 100 "Utility/Gtk/TerminalWindow.vala"
	_tmp15_ = self->priv->term;
#line 100 "Utility/Gtk/TerminalWindow.vala"
	_tmp16_ = color;
#line 100 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_color_foreground (_tmp15_, &_tmp16_);
#line 102 "Utility/Gtk/TerminalWindow.vala"
	gdk_rgba_parse (&color, "#404040");
#line 103 "Utility/Gtk/TerminalWindow.vala"
	_tmp17_ = self->priv->term;
#line 103 "Utility/Gtk/TerminalWindow.vala"
	_tmp18_ = color;
#line 103 "Utility/Gtk/TerminalWindow.vala"
	vte_terminal_set_color_background (_tmp17_, &_tmp18_);
#line 107 "Utility/Gtk/TerminalWindow.vala"
	_tmp19_ = self->priv->term;
#line 107 "Utility/Gtk/TerminalWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 109 "Utility/Gtk/TerminalWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 339 "TerminalWindow.c"
}

void
terminal_window_start_shell (TerminalWindow* self)
{
	gchar** argv = NULL;
	gchar** _tmp0_;
	gint argv_length1;
	gint _argv_size_;
	gchar* _tmp1_;
	gchar** env = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint env_length1;
	gint _env_size_;
	GError* _inner_error0_ = NULL;
#line 112 "Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 114 "Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = g_new0 (gchar*, 1 + 1);
#line 114 "Utility/Gtk/TerminalWindow.vala"
	argv = _tmp0_;
#line 114 "Utility/Gtk/TerminalWindow.vala"
	argv_length1 = 1;
#line 114 "Utility/Gtk/TerminalWindow.vala"
	_argv_size_ = argv_length1;
#line 115 "Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = g_strdup ("/bin/sh");
#line 115 "Utility/Gtk/TerminalWindow.vala"
	_g_free0 (argv[0]);
#line 115 "Utility/Gtk/TerminalWindow.vala"
	argv[0] = _tmp1_;
#line 117 "Utility/Gtk/TerminalWindow.vala"
	_tmp3_ = _tmp2_ = g_get_environ ();
#line 117 "Utility/Gtk/TerminalWindow.vala"
	env = _tmp3_;
#line 117 "Utility/Gtk/TerminalWindow.vala"
	env_length1 = _vala_array_length (_tmp2_);
#line 117 "Utility/Gtk/TerminalWindow.vala"
	_env_size_ = env_length1;
#line 380 "TerminalWindow.c"
	{
		VteTerminal* _tmp4_;
		const gchar* _tmp5_;
		GPid _tmp6_ = 0;
#line 121 "Utility/Gtk/TerminalWindow.vala"
		self->is_running = TRUE;
#line 123 "Utility/Gtk/TerminalWindow.vala"
		_tmp4_ = self->priv->term;
#line 123 "Utility/Gtk/TerminalWindow.vala"
		_tmp5_ = tee_jee_process_helper_TEMP_DIR;
#line 123 "Utility/Gtk/TerminalWindow.vala"
		vte_terminal_spawn_sync (_tmp4_, VTE_PTY_DEFAULT, _tmp5_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp6_, NULL, &_inner_error0_);
#line 123 "Utility/Gtk/TerminalWindow.vala"
		self->priv->child_pid = _tmp6_;
#line 123 "Utility/Gtk/TerminalWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 397 "TerminalWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 119 "Utility/Gtk/TerminalWindow.vala"
		e = _inner_error0_;
#line 119 "Utility/Gtk/TerminalWindow.vala"
		_inner_error0_ = NULL;
#line 135 "Utility/Gtk/TerminalWindow.vala"
		_tmp7_ = e;
#line 135 "Utility/Gtk/TerminalWindow.vala"
		_tmp8_ = _tmp7_->message;
#line 135 "Utility/Gtk/TerminalWindow.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 119 "Utility/Gtk/TerminalWindow.vala"
		_g_error_free0 (e);
#line 419 "TerminalWindow.c"
	}
	__finally0:
#line 119 "Utility/Gtk/TerminalWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "Utility/Gtk/TerminalWindow.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 119 "Utility/Gtk/TerminalWindow.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 119 "Utility/Gtk/TerminalWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 119 "Utility/Gtk/TerminalWindow.vala"
		g_clear_error (&_inner_error0_);
#line 119 "Utility/Gtk/TerminalWindow.vala"
		return;
#line 434 "TerminalWindow.c"
	}
#line 112 "Utility/Gtk/TerminalWindow.vala"
	env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 112 "Utility/Gtk/TerminalWindow.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 440 "TerminalWindow.c"
}

static void
_terminal_window_script_exit_vte_terminal_child_exited (VteTerminal* _sender,
                                                        gint status,
                                                        gpointer self)
{
#line 163 "Utility/Gtk/TerminalWindow.vala"
	terminal_window_script_exit ((TerminalWindow*) self, status);
#line 450 "TerminalWindow.c"
}

void
terminal_window_execute_script (TerminalWindow* self,
                                const gchar* script_path,
                                gboolean wait)
{
	gchar** argv = NULL;
	gchar** _tmp0_;
	gint argv_length1;
	gint _argv_size_;
	gchar* _tmp1_;
	gchar** env = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint env_length1;
	gint _env_size_;
	GError* _inner_error0_ = NULL;
#line 139 "Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 139 "Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (script_path != NULL);
#line 141 "Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = g_new0 (gchar*, 1 + 1);
#line 141 "Utility/Gtk/TerminalWindow.vala"
	argv = _tmp0_;
#line 141 "Utility/Gtk/TerminalWindow.vala"
	argv_length1 = 1;
#line 141 "Utility/Gtk/TerminalWindow.vala"
	_argv_size_ = argv_length1;
#line 142 "Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = g_strdup (script_path);
#line 142 "Utility/Gtk/TerminalWindow.vala"
	_g_free0 (argv[0]);
#line 142 "Utility/Gtk/TerminalWindow.vala"
	argv[0] = _tmp1_;
#line 144 "Utility/Gtk/TerminalWindow.vala"
	_tmp3_ = _tmp2_ = g_get_environ ();
#line 144 "Utility/Gtk/TerminalWindow.vala"
	env = _tmp3_;
#line 144 "Utility/Gtk/TerminalWindow.vala"
	env_length1 = _vala_array_length (_tmp2_);
#line 144 "Utility/Gtk/TerminalWindow.vala"
	_env_size_ = env_length1;
#line 495 "TerminalWindow.c"
	{
		VteTerminal* _tmp4_;
		const gchar* _tmp5_;
		GPid _tmp6_ = 0;
		VteTerminal* _tmp7_;
		VteTerminal* _tmp8_;
#line 148 "Utility/Gtk/TerminalWindow.vala"
		self->is_running = TRUE;
#line 150 "Utility/Gtk/TerminalWindow.vala"
		_tmp4_ = self->priv->term;
#line 150 "Utility/Gtk/TerminalWindow.vala"
		_tmp5_ = tee_jee_process_helper_TEMP_DIR;
#line 150 "Utility/Gtk/TerminalWindow.vala"
		vte_terminal_spawn_sync (_tmp4_, VTE_PTY_DEFAULT, _tmp5_, argv, env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp6_, NULL, &_inner_error0_);
#line 150 "Utility/Gtk/TerminalWindow.vala"
		self->priv->child_pid = _tmp6_;
#line 150 "Utility/Gtk/TerminalWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 514 "TerminalWindow.c"
			goto __catch0_g_error;
		}
#line 161 "Utility/Gtk/TerminalWindow.vala"
		_tmp7_ = self->priv->term;
#line 161 "Utility/Gtk/TerminalWindow.vala"
		vte_terminal_watch_child (_tmp7_, self->priv->child_pid);
#line 163 "Utility/Gtk/TerminalWindow.vala"
		_tmp8_ = self->priv->term;
#line 163 "Utility/Gtk/TerminalWindow.vala"
		g_signal_connect_object (_tmp8_, "child-exited", (GCallback) _terminal_window_script_exit_vte_terminal_child_exited, self, 0);
#line 165 "Utility/Gtk/TerminalWindow.vala"
		if (wait) {
#line 166 "Utility/Gtk/TerminalWindow.vala"
			while (TRUE) {
#line 166 "Utility/Gtk/TerminalWindow.vala"
				if (!self->is_running) {
#line 166 "Utility/Gtk/TerminalWindow.vala"
					break;
#line 533 "TerminalWindow.c"
				}
#line 167 "Utility/Gtk/TerminalWindow.vala"
				tee_jee_system_sleep (200);
#line 168 "Utility/Gtk/TerminalWindow.vala"
				tee_jee_gtk_helper_gtk_do_events ();
#line 539 "TerminalWindow.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 146 "Utility/Gtk/TerminalWindow.vala"
		e = _inner_error0_;
#line 146 "Utility/Gtk/TerminalWindow.vala"
		_inner_error0_ = NULL;
#line 173 "Utility/Gtk/TerminalWindow.vala"
		_tmp9_ = e;
#line 173 "Utility/Gtk/TerminalWindow.vala"
		_tmp10_ = _tmp9_->message;
#line 173 "Utility/Gtk/TerminalWindow.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 146 "Utility/Gtk/TerminalWindow.vala"
		_g_error_free0 (e);
#line 561 "TerminalWindow.c"
	}
	__finally0:
#line 146 "Utility/Gtk/TerminalWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "Utility/Gtk/TerminalWindow.vala"
		env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 146 "Utility/Gtk/TerminalWindow.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 146 "Utility/Gtk/TerminalWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "Utility/Gtk/TerminalWindow.vala"
		g_clear_error (&_inner_error0_);
#line 146 "Utility/Gtk/TerminalWindow.vala"
		return;
#line 576 "TerminalWindow.c"
	}
#line 139 "Utility/Gtk/TerminalWindow.vala"
	env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 139 "Utility/Gtk/TerminalWindow.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 582 "TerminalWindow.c"
}

void
terminal_window_script_exit (TerminalWindow* self,
                             gint status)
{
	GtkContainer* _tmp0_;
	GtkContainer* _tmp1_;
#line 177 "Utility/Gtk/TerminalWindow.vala"
	g_return_if_fail (self != NULL);
#line 179 "Utility/Gtk/TerminalWindow.vala"
	self->is_running = FALSE;
#line 181 "Utility/Gtk/TerminalWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 186 "Utility/Gtk/TerminalWindow.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 186 "Utility/Gtk/TerminalWindow.vala"
	_tmp1_ = _tmp0_;
#line 186 "Utility/Gtk/TerminalWindow.vala"
	if (_tmp1_ != NULL) {
#line 603 "TerminalWindow.c"
		GtkWindow* _tmp2_;
#line 187 "Utility/Gtk/TerminalWindow.vala"
		_tmp2_ = self->priv->parent_win;
#line 187 "Utility/Gtk/TerminalWindow.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp2_);
#line 609 "TerminalWindow.c"
	}
}

TerminalWindow*
terminal_window_construct (GType object_type)
{
	TerminalWindow * self = NULL;
#line 36 "Utility/Gtk/TerminalWindow.vala"
	self = (TerminalWindow*) g_object_new (object_type, NULL);
#line 36 "Utility/Gtk/TerminalWindow.vala"
	return self;
#line 621 "TerminalWindow.c"
}

TerminalWindow*
terminal_window_new (void)
{
#line 36 "Utility/Gtk/TerminalWindow.vala"
	return terminal_window_construct (TYPE_TERMINAL_WINDOW);
#line 629 "TerminalWindow.c"
}

static void
terminal_window_class_init (TerminalWindowClass * klass,
                            gpointer klass_data)
{
#line 36 "Utility/Gtk/TerminalWindow.vala"
	terminal_window_parent_class = g_type_class_peek_parent (klass);
#line 36 "Utility/Gtk/TerminalWindow.vala"
	g_type_class_adjust_private_offset (klass, &TerminalWindow_private_offset);
#line 36 "Utility/Gtk/TerminalWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_window_finalize;
#line 642 "TerminalWindow.c"
}

static void
terminal_window_instance_init (TerminalWindow * self,
                               gpointer klass)
{
#line 36 "Utility/Gtk/TerminalWindow.vala"
	self->priv = terminal_window_get_instance_private (self);
#line 41 "Utility/Gtk/TerminalWindow.vala"
	self->priv->def_width = 800;
#line 42 "Utility/Gtk/TerminalWindow.vala"
	self->priv->def_height = 600;
#line 45 "Utility/Gtk/TerminalWindow.vala"
	self->priv->parent_win = NULL;
#line 46 "Utility/Gtk/TerminalWindow.vala"
	self->is_running = FALSE;
#line 659 "TerminalWindow.c"
}

static void
terminal_window_finalize (GObject * obj)
{
	TerminalWindow * self;
#line 36 "Utility/Gtk/TerminalWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TERMINAL_WINDOW, TerminalWindow);
#line 38 "Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->vbox_main);
#line 39 "Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->term);
#line 45 "Utility/Gtk/TerminalWindow.vala"
	_g_object_unref0 (self->priv->parent_win);
#line 36 "Utility/Gtk/TerminalWindow.vala"
	G_OBJECT_CLASS (terminal_window_parent_class)->finalize (obj);
#line 676 "TerminalWindow.c"
}

static GType
terminal_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalWindow), 0, (GInstanceInitFunc) terminal_window_instance_init, NULL };
	GType terminal_window_type_id;
	terminal_window_type_id = g_type_register_static (gtk_window_get_type (), "TerminalWindow", &g_define_type_info, 0);
	TerminalWindow_private_offset = g_type_add_instance_private (terminal_window_type_id, sizeof (TerminalWindowPrivate));
	return terminal_window_type_id;
}

GType
terminal_window_get_type (void)
{
	static volatile gsize terminal_window_type_id__once = 0;
	if (g_once_init_enter (&terminal_window_type_id__once)) {
		GType terminal_window_type_id;
		terminal_window_type_id = terminal_window_get_type_once ();
		g_once_init_leave (&terminal_window_type_id__once, terminal_window_type_id);
	}
	return terminal_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

