/* TeeJee.FileSystem.c generated by valac 0.56.17, the Vala compiler
 * generated from TeeJee.FileSystem.vala, do not modify */

/*
 * TeeJee.FileSystem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <glib-object.h>

#define TEE_JEE_FILE_SYSTEM_KB ((gint64) 1000)
#define TEE_JEE_FILE_SYSTEM_MB (1000 * TEE_JEE_FILE_SYSTEM_KB)
#define TEE_JEE_FILE_SYSTEM_GB (1000 * TEE_JEE_FILE_SYSTEM_MB)
#define TEE_JEE_FILE_SYSTEM_TB (1000 * TEE_JEE_FILE_SYSTEM_GB)
#define TEE_JEE_FILE_SYSTEM_KiB ((gint64) 1024)
#define TEE_JEE_FILE_SYSTEM_MiB (1024 * TEE_JEE_FILE_SYSTEM_KiB)
#define TEE_JEE_FILE_SYSTEM_GiB (1024 * TEE_JEE_FILE_SYSTEM_MiB)
#define TEE_JEE_FILE_SYSTEM_TiB (1024 * TEE_JEE_FILE_SYSTEM_GiB)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN gchar* tee_jee_file_system_file_parent (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_file_basename (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
VALA_EXTERN gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
VALA_EXTERN gboolean tee_jee_file_system_file_exists (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_delete (const gchar* file_path);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
VALA_EXTERN gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
VALA_EXTERN gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar** std_out,
                                       gchar** std_err);
VALA_EXTERN gchar* tee_jee_file_system_file_read (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
VALA_EXTERN gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
VALA_EXTERN gboolean tee_jee_file_system_file_copy (const gchar* src_file,
                                        const gchar* dest_file);
VALA_EXTERN void tee_jee_file_system_file_move (const gchar* src_file,
                                    const gchar* dest_file);
VALA_EXTERN gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
VALA_EXTERN gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
VALA_EXTERN void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
VALA_EXTERN gboolean tee_jee_file_system_dir_delete (const gchar* dir_path,
                                         gboolean show_message);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
VALA_EXTERN gboolean tee_jee_file_system_dir_is_empty (const gchar* dir_path);
VALA_EXTERN GeeArrayList* tee_jee_file_system_dir_list_names (const gchar* path);
static gint __lambda12_ (const gchar* a,
                  const gchar* b);
static gint ___lambda12__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
VALA_EXTERN gboolean tee_jee_file_system_chown (const gchar* dir_path,
                                    const gchar* user,
                                    const gchar* group);
VALA_EXTERN gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
VALA_EXTERN gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

gchar*
tee_jee_file_system_file_parent (const gchar* file_path)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 45 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp3_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	result = _tmp5_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 159 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_basename (const gchar* file_path)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 49 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_basename (_tmp1_);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "Utility/TeeJee.FileSystem.vala"
	result = _tmp3_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 186 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_path_combine (const gchar* path1,
                                  const gchar* path2)
{
	gchar* _tmp0_;
	gchar* result;
#line 53 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path1 != NULL, NULL);
#line 53 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path2 != NULL, NULL);
#line 54 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_build_path ("/", path1, path2, NULL);
#line 54 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 54 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 205 "TeeJee.FileSystem.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 232 "TeeJee.FileSystem.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 238 "TeeJee.FileSystem.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 244 "TeeJee.FileSystem.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 248 "TeeJee.FileSystem.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 256 "TeeJee.FileSystem.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 260 "TeeJee.FileSystem.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 272 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_remove_trailing_slash (const gchar* path)
{
	gchar* result;
#line 57 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 58 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_suffix (path, "/")) {
#line 283 "TeeJee.FileSystem.c"
		gint _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = strlen (path);
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = string_slice (path, (glong) 0, (glong) (_tmp1_ - 1));
#line 59 "Utility/TeeJee.FileSystem.vala"
		result = _tmp2_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 297 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp3_;
#line 62 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup (path);
#line 62 "Utility/TeeJee.FileSystem.vala"
		result = _tmp3_;
#line 62 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 306 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_exists (const gchar* file_path)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 68 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 70 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 71 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = !g_file_test (file_path, G_FILE_TEST_IS_DIR);
#line 321 "TeeJee.FileSystem.c"
	} else {
#line 70 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 325 "TeeJee.FileSystem.c"
	}
#line 70 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 70 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 331 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_delete (const gchar* file_path)
{
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 74 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 342 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 79 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 79 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 80 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 80 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 355 "TeeJee.FileSystem.c"
			GFile* _tmp2_;
#line 81 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 81 "Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp2_, NULL, &_inner_error0_);
#line 81 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 365 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
		}
#line 83 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 83 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 83 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 375 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 78 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 78 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 85 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = e;
#line 85 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_->message;
#line 85 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 86 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_strdup_printf (": %s", file_path);
#line 86 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 86 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strconcat (_ ("Failed to delete file"), _tmp6_, NULL);
#line 86 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 86 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 86 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 86 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp6_);
#line 87 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 87 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 87 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 417 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 78 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 78 "Utility/TeeJee.FileSystem.vala"
	return _tmp9_;
#line 426 "TeeJee.FileSystem.c"
}

static glong
long_parse (const gchar* str,
            guint _base)
{
	glong result;
#line 315 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0L);
#line 316 "glib-2.0.vapi"
	result = strtol (str, NULL, (gint) _base);
#line 316 "glib-2.0.vapi"
	return result;
#line 440 "TeeJee.FileSystem.c"
}

gint64
tee_jee_file_system_file_line_count (const gchar* file_path)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gint64 _tmp10_;
	gint64 result;
#line 91 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 93 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file_path);
#line 93 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 93 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("wc -l '%s'", _tmp1_);
#line 93 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 93 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 93 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 95 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 95 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 95 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 95 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 95 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 96 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 96 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 96 "Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 96 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 96 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = (gint64) long_parse (_tmp9_, (guint) 0);
#line 96 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 96 "Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 96 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 96 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 96 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 96 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 508 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_read (const gchar* file_path)
{
	gchar* txt = NULL;
	gsize size = 0UL;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 99 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 520 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
#line 107 "Utility/TeeJee.FileSystem.vala"
		g_file_get_contents (file_path, &_tmp0_, &_tmp1_, &_inner_error0_);
#line 107 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 107 "Utility/TeeJee.FileSystem.vala"
		txt = _tmp0_;
#line 107 "Utility/TeeJee.FileSystem.vala"
		size = _tmp1_;
#line 107 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 534 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 108 "Utility/TeeJee.FileSystem.vala"
		result = txt;
#line 108 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 541 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 106 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 106 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 111 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = e;
#line 111 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_->message;
#line 111 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 112 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf (": %s", file_path);
#line 112 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 112 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_ ("Failed to read file"), _tmp5_, NULL);
#line 112 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 112 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 112 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 112 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 106 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 579 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 106 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 106 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 106 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 592 "TeeJee.FileSystem.c"
	}
#line 115 "Utility/TeeJee.FileSystem.vala"
	result = NULL;
#line 115 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (txt);
#line 115 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 600 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_write (const gchar* file_path,
                                const gchar* contents)
{
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 118 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 118 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 614 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp5_;
		GFileOutputStream* _tmp6_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
		GDataOutputStream* _tmp10_;
#line 124 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (file_path);
#line 124 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 124 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_dir_create (_tmp1_, FALSE);
#line 124 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 126 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_file_new_for_path (file_path);
#line 126 "Utility/TeeJee.FileSystem.vala"
		file = _tmp2_;
#line 127 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = file;
#line 127 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 645 "TeeJee.FileSystem.c"
			GFile* _tmp4_;
#line 128 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file;
#line 128 "Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error0_);
#line 128 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 655 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
		}
#line 131 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = file;
#line 131 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_file_create (_tmp5_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 131 "Utility/TeeJee.FileSystem.vala"
		file_stream = _tmp6_;
#line 131 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 669 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 132 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = file_stream;
#line 132 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_data_output_stream_new ((GOutputStream*) _tmp7_);
#line 132 "Utility/TeeJee.FileSystem.vala"
		data_stream = _tmp8_;
#line 133 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = data_stream;
#line 133 "Utility/TeeJee.FileSystem.vala"
		g_data_output_stream_put_string (_tmp9_, contents, NULL, &_inner_error0_);
#line 133 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 133 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 133 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 690 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 134 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = data_stream;
#line 134 "Utility/TeeJee.FileSystem.vala"
		g_output_stream_close ((GOutputStream*) _tmp10_, NULL, &_inner_error0_);
#line 134 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 134 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 134 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 705 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 135 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 135 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (data_stream);
#line 135 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_stream);
#line 135 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 135 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 718 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 122 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 122 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 138 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 138 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 138 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 139 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", file_path);
#line 139 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 139 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to write file"), _tmp14_, NULL);
#line 139 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 139 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 139 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 139 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 140 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 140 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 140 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 760 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 122 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 122 "Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 769 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_copy (const gchar* src_file,
                               const gchar* dest_file)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 144 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 144 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dest_file != NULL, FALSE);
#line 782 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 146 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 146 "Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 147 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 147 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 795 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 148 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 148 "Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 149 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 149 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 149 "Utility/TeeJee.FileSystem.vala"
			g_file_copy (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 149 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 149 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 816 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 150 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 150 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 150 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_src);
#line 150 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 827 "TeeJee.FileSystem.c"
		}
#line 145 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 831 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 145 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 145 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 154 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 154 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 154 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 155 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 155 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 155 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_ ("Failed to copy file"), _tmp8_, NULL);
#line 155 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 155 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 155 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 155 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 145 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 869 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 145 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 874 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 145 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 145 "Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 882 "TeeJee.FileSystem.c"
	}
#line 158 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 158 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 888 "TeeJee.FileSystem.c"
}

void
tee_jee_file_system_file_move (const gchar* src_file,
                               const gchar* dest_file)
{
	GError* _inner_error0_ = NULL;
#line 161 "Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (src_file != NULL);
#line 161 "Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (dest_file != NULL);
#line 900 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 163 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 163 "Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 164 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 164 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 913 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 165 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 165 "Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 166 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 166 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 166 "Utility/TeeJee.FileSystem.vala"
			g_file_move (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 166 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 166 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 934 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 164 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 939 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 169 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_strdup_printf (": '%s'", src_file);
#line 169 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 169 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = g_strconcat (_ ("File not found"), _tmp6_, NULL);
#line 169 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp7_;
#line 169 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 169 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp8_);
#line 169 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp6_);
#line 959 "TeeJee.FileSystem.c"
		}
#line 162 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 963 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 162 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 162 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 173 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 173 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 173 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 174 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 174 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 174 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strconcat (_ ("Failed to move file"), _tmp12_, NULL);
#line 174 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 174 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 174 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 174 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 162 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1001 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 162 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 162 "Utility/TeeJee.FileSystem.vala"
		return;
#line 1012 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_is_symlink (const gchar* file_path)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 178 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 1023 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 181 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 181 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 183 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 183 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1036 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileType file_type = 0;
			GFileInfo* _tmp7_;
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_query_info (_tmp2_, _tmp4_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 185 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 185 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 185 "Utility/TeeJee.FileSystem.vala"
			info = _tmp6_;
#line 185 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 1063 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 187 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = info;
#line 187 "Utility/TeeJee.FileSystem.vala"
			file_type = g_file_info_get_file_type (_tmp7_);
#line 189 "Utility/TeeJee.FileSystem.vala"
			result = file_type == G_FILE_TYPE_SYMBOLIC_LINK;
#line 189 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 189 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 189 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1078 "TeeJee.FileSystem.c"
		}
#line 180 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1082 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 180 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 180 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 193 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = e;
#line 193 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = _tmp8_->message;
#line 193 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp9_, FALSE, FALSE);
#line 180 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1102 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 180 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1107 "TeeJee.FileSystem.c"
		gboolean _tmp10_ = FALSE;
#line 180 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 180 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 180 "Utility/TeeJee.FileSystem.vala"
		return _tmp10_;
#line 1115 "TeeJee.FileSystem.c"
	}
#line 196 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 196 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1121 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_gzip (const gchar* src_file)
{
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean result;
#line 199 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 201 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strconcat (src_file, ".gz", NULL);
#line 201 "Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 202 "Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 204 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 204 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 204 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gzip '%s'", _tmp2_);
#line 204 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 204 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 204 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 206 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 206 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 206 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 206 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 206 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 208 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 208 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 208 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 208 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 208 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 208 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1181 "TeeJee.FileSystem.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1200 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_resolve_executable_path (const gchar* file_path)
{
	gchar* result;
#line 211 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 213 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (file_path, "/")) {
#line 1211 "TeeJee.FileSystem.c"
		gchar* _tmp0_;
#line 214 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup (file_path);
#line 214 "Utility/TeeJee.FileSystem.vala"
		result = _tmp0_;
#line 214 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1219 "TeeJee.FileSystem.c"
	} else {
#line 216 "Utility/TeeJee.FileSystem.vala"
		if (!string_contains (file_path, "/")) {
#line 1223 "TeeJee.FileSystem.c"
			gchar* _tmp1_;
#line 217 "Utility/TeeJee.FileSystem.vala"
			_tmp1_ = g_find_program_in_path (file_path);
#line 217 "Utility/TeeJee.FileSystem.vala"
			result = _tmp1_;
#line 217 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1231 "TeeJee.FileSystem.c"
		} else {
#line 219 "Utility/TeeJee.FileSystem.vala"
			if (g_str_has_prefix (file_path, "./")) {
#line 1235 "TeeJee.FileSystem.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp2_ = g_get_current_dir ();
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp3_ = _tmp2_;
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp4_ = strlen (file_path);
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp5_ = _tmp4_;
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp6_ = string_slice (file_path, (glong) 2, (glong) _tmp5_);
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp6_;
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp8_ = tee_jee_file_system_path_combine (_tmp3_, _tmp7_);
#line 220 "Utility/TeeJee.FileSystem.vala"
				_tmp9_ = _tmp8_;
#line 220 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp7_);
#line 220 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp3_);
#line 220 "Utility/TeeJee.FileSystem.vala"
				result = _tmp9_;
#line 220 "Utility/TeeJee.FileSystem.vala"
				return result;
#line 1268 "TeeJee.FileSystem.c"
			} else {
#line 222 "Utility/TeeJee.FileSystem.vala"
				if (g_str_has_prefix (file_path, "../")) {
#line 1272 "TeeJee.FileSystem.c"
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_get_current_dir ();
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp12_ = tee_jee_file_system_file_parent (_tmp11_);
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp13_ = _tmp12_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp14_ = strlen (file_path);
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp15_ = _tmp14_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp16_ = string_slice (file_path, (glong) 3, (glong) _tmp15_);
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp17_ = _tmp16_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp18_ = tee_jee_file_system_path_combine (_tmp13_, _tmp17_);
#line 223 "Utility/TeeJee.FileSystem.vala"
					_tmp19_ = _tmp18_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp17_);
#line 223 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp13_);
#line 223 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 223 "Utility/TeeJee.FileSystem.vala"
					result = _tmp19_;
#line 223 "Utility/TeeJee.FileSystem.vala"
					return result;
#line 1313 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 226 "Utility/TeeJee.FileSystem.vala"
					_tmp20_ = g_get_current_dir ();
#line 226 "Utility/TeeJee.FileSystem.vala"
					_tmp21_ = _tmp20_;
#line 226 "Utility/TeeJee.FileSystem.vala"
					_tmp22_ = tee_jee_file_system_path_combine (_tmp21_, file_path);
#line 226 "Utility/TeeJee.FileSystem.vala"
					_tmp23_ = _tmp22_;
#line 226 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp21_);
#line 226 "Utility/TeeJee.FileSystem.vala"
					result = _tmp23_;
#line 226 "Utility/TeeJee.FileSystem.vala"
					return result;
#line 1333 "TeeJee.FileSystem.c"
				}
			}
		}
	}
}

gchar*
tee_jee_file_system_file_get_symlink_target (const gchar* file_path)
{
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 232 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1348 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 235 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 235 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 236 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 236 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1362 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error0_);
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 237 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 237 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 237 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1393 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 237 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 237 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 237 "Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 238 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 238 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_file_info_get_symlink_target (_tmp9_);
#line 238 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 238 "Utility/TeeJee.FileSystem.vala"
			result = _tmp11_;
#line 238 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 238 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 238 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 238 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1420 "TeeJee.FileSystem.c"
		}
#line 233 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 233 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1426 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 233 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 233 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 242 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 242 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 242 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 233 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1446 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 233 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 233 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1457 "TeeJee.FileSystem.c"
	}
#line 245 "Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strdup ("");
#line 245 "Utility/TeeJee.FileSystem.vala"
	result = _tmp14_;
#line 245 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1465 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_exists (const gchar* dir_path)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 250 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 252 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (dir_path, G_FILE_TEST_EXISTS)) {
#line 252 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (dir_path, G_FILE_TEST_IS_DIR);
#line 1479 "TeeJee.FileSystem.c"
	} else {
#line 252 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 1483 "TeeJee.FileSystem.c"
	}
#line 252 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 252 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1489 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_create (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 255 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 1501 "TeeJee.FileSystem.c"
	{
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 260 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 260 "Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 262 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 262 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL) == FALSE) {
#line 1514 "TeeJee.FileSystem.c"
			gboolean ok = FALSE;
			GFile* _tmp2_;
#line 264 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 264 "Utility/TeeJee.FileSystem.vala"
			ok = g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error0_);
#line 264 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 264 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 1525 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 266 "Utility/TeeJee.FileSystem.vala"
			if (show_message) {
#line 267 "Utility/TeeJee.FileSystem.vala"
				if (ok) {
#line 1532 "TeeJee.FileSystem.c"
					gchar* _tmp3_;
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 268 "Utility/TeeJee.FileSystem.vala"
					_tmp3_ = g_strdup_printf (": %s", dir_path);
#line 268 "Utility/TeeJee.FileSystem.vala"
					_tmp4_ = _tmp3_;
#line 268 "Utility/TeeJee.FileSystem.vala"
					_tmp5_ = g_strconcat (_ ("Created directory"), _tmp4_, NULL);
#line 268 "Utility/TeeJee.FileSystem.vala"
					_tmp6_ = _tmp5_;
#line 268 "Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 268 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp6_);
#line 268 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp4_);
#line 1551 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp7_ = g_strdup_printf (": %s", dir_path);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp8_ = _tmp7_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp9_ = g_strconcat (_ ("Failed to create directory"), _tmp8_, NULL);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_tmp10_ = _tmp9_;
#line 271 "Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp10_);
#line 271 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp8_);
#line 1571 "TeeJee.FileSystem.c"
				}
			}
		}
#line 276 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 276 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 276 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1581 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 259 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 259 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 279 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 279 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 279 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 280 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", dir_path);
#line 280 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 280 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to create directory"), _tmp14_, NULL);
#line 280 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 280 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 280 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 280 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 281 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 281 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 281 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1623 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 259 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 259 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 259 "Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 1632 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_delete (const gchar* dir_path,
                                gboolean show_message)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
	gboolean result;
#line 285 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 289 "Utility/TeeJee.FileSystem.vala"
	if (!tee_jee_file_system_dir_exists (dir_path)) {
#line 290 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 290 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1661 "TeeJee.FileSystem.c"
	}
#line 293 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 293 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 293 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("rm -rf '%s'", _tmp1_);
#line 293 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 293 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 293 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 295 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 295 "Utility/TeeJee.FileSystem.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 298 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 298 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_process_helper_exec_sync (_tmp5_, &_tmp6_, &_tmp7_);
#line 298 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 298 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp6_;
#line 298 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 298 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp7_;
#line 298 "Utility/TeeJee.FileSystem.vala"
	status = _tmp8_;
#line 300 "Utility/TeeJee.FileSystem.vala"
	if (show_message) {
#line 301 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 1697 "TeeJee.FileSystem.c"
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_strdup_printf (": %s", dir_path);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp9_;
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strconcat (_ ("Deleted directory"), _tmp10_, NULL);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 302 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp12_, FALSE);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp12_);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp10_);
#line 1716 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 305 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_strdup_printf (": %s", dir_path);
#line 305 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 305 "Utility/TeeJee.FileSystem.vala"
			_tmp15_ = g_strconcat (_ ("Failed to delete directory"), _tmp14_, NULL);
#line 305 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = _tmp15_;
#line 305 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 305 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp16_);
#line 305 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp14_);
#line 306 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = std_out;
#line 306 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 307 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = std_err;
#line 307 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 1746 "TeeJee.FileSystem.c"
		}
	}
#line 311 "Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 311 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 311 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 311 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 311 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1759 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_is_empty (const gchar* dir_path)
{
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 314 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 1770 "TeeJee.FileSystem.c"
	{
		gboolean is_empty = FALSE;
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 319 "Utility/TeeJee.FileSystem.vala"
		is_empty = TRUE;
#line 320 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 320 "Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 321 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 321 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1786 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFileEnumerator* enu = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileEnumerator* _tmp5_;
			GFileEnumerator* _tmp6_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 323 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 323 "Utility/TeeJee.FileSystem.vala"
			enu = _tmp6_;
#line 323 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 323 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 323 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 1814 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 324 "Utility/TeeJee.FileSystem.vala"
			while (TRUE) {
#line 1819 "TeeJee.FileSystem.c"
				GFileInfo* _tmp7_ = NULL;
				GFileEnumerator* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				GFileInfo* _tmp11_;
#line 324 "Utility/TeeJee.FileSystem.vala"
				_tmp8_ = enu;
#line 324 "Utility/TeeJee.FileSystem.vala"
				_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 324 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp9_;
#line 324 "Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (enu);
#line 324 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (info);
#line 324 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (dir);
#line 1839 "TeeJee.FileSystem.c"
					goto __catch0_g_error;
				}
#line 324 "Utility/TeeJee.FileSystem.vala"
				_tmp10_ = _tmp7_;
#line 324 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = NULL;
#line 324 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 324 "Utility/TeeJee.FileSystem.vala"
				info = _tmp10_;
#line 324 "Utility/TeeJee.FileSystem.vala"
				_tmp11_ = info;
#line 324 "Utility/TeeJee.FileSystem.vala"
				if (!(_tmp11_ != NULL)) {
#line 324 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (_tmp7_);
#line 324 "Utility/TeeJee.FileSystem.vala"
					break;
#line 1858 "TeeJee.FileSystem.c"
				}
#line 325 "Utility/TeeJee.FileSystem.vala"
				is_empty = FALSE;
#line 326 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 326 "Utility/TeeJee.FileSystem.vala"
				break;
#line 1866 "TeeJee.FileSystem.c"
			}
#line 321 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (enu);
#line 321 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 1872 "TeeJee.FileSystem.c"
		}
#line 329 "Utility/TeeJee.FileSystem.vala"
		result = is_empty;
#line 329 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 329 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1880 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 318 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 318 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 332 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 332 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 332 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 333 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 333 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 333 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1904 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 318 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 318 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 318 "Utility/TeeJee.FileSystem.vala"
	return _tmp14_;
#line 1913 "TeeJee.FileSystem.c"
}

static gint
__lambda12_ (const gchar* a,
             const gchar* b)
{
	GCompareFunc _tmp0_;
	gint result;
#line 356 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 356 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 357 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 357 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_ (a, b);
#line 357 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1932 "TeeJee.FileSystem.c"
}

static gint
___lambda12__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda12_ ((const gchar*) a, (const gchar*) b);
#line 356 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1944 "TeeJee.FileSystem.c"
}

GeeArrayList*
tee_jee_file_system_dir_list_names (const gchar* path)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	gpointer entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	gpointer _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 337 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 339 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 339 "Utility/TeeJee.FileSystem.vala"
	list = _tmp0_;
#line 1967 "TeeJee.FileSystem.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 343 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 343 "Utility/TeeJee.FileSystem.vala"
		f_home = _tmp1_;
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = f_home;
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 344 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 344 "Utility/TeeJee.FileSystem.vala"
		enumerator = _tmp6_;
#line 344 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (f_home);
#line 2000 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 346 "Utility/TeeJee.FileSystem.vala"
		while (TRUE) {
#line 2005 "TeeJee.FileSystem.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 346 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = enumerator;
#line 346 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 346 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp9_;
#line 346 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 346 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 346 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (enumerator);
#line 346 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (f_home);
#line 2031 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 346 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp7_;
#line 346 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = NULL;
#line 346 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 346 "Utility/TeeJee.FileSystem.vala"
			file = _tmp10_;
#line 346 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = file;
#line 346 "Utility/TeeJee.FileSystem.vala"
			if (!(_tmp11_ != NULL)) {
#line 346 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 346 "Utility/TeeJee.FileSystem.vala"
				break;
#line 2050 "TeeJee.FileSystem.c"
			}
#line 347 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = file;
#line 347 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 347 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 347 "Utility/TeeJee.FileSystem.vala"
			name = _tmp14_;
#line 348 "Utility/TeeJee.FileSystem.vala"
			_tmp15_ = list;
#line 348 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = name;
#line 348 "Utility/TeeJee.FileSystem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 346 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (name);
#line 346 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp7_);
#line 2070 "TeeJee.FileSystem.c"
		}
#line 341 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 341 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (enumerator);
#line 341 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (f_home);
#line 2078 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 341 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 341 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 352 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = e;
#line 352 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_->message;
#line 352 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 341 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 2098 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 341 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (list);
#line 341 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 341 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 2111 "TeeJee.FileSystem.c"
	}
#line 356 "Utility/TeeJee.FileSystem.vala"
	entry_compare = ___lambda12__gcompare_data_func;
#line 356 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 356 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 359 "Utility/TeeJee.FileSystem.vala"
	_tmp19_ = list;
#line 359 "Utility/TeeJee.FileSystem.vala"
	_tmp20_ = entry_compare;
#line 359 "Utility/TeeJee.FileSystem.vala"
	_tmp20__target = entry_compare_target;
#line 359 "Utility/TeeJee.FileSystem.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 359 "Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 359 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 359 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 359 "Utility/TeeJee.FileSystem.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 361 "Utility/TeeJee.FileSystem.vala"
	result = list;
#line 361 "Utility/TeeJee.FileSystem.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 361 "Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 361 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 361 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 361 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2147 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_chown (const gchar* dir_path,
                           const gchar* user,
                           const gchar* group)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint status = 0;
	gboolean result;
#line 364 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 364 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 364 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 365 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 365 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 365 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chown %s:%s -R '%s'", user, group, _tmp1_);
#line 365 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 365 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 365 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 366 "Utility/TeeJee.FileSystem.vala"
	status = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 367 "Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 367 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 367 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2188 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_format_file_size (guint64 size,
                                      gboolean binary_units,
                                      const gchar* unit,
                                      gboolean show_units,
                                      gint decimals)
{
	gint _tmp0_ = 0;
	guint64 unit_k = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 unit_m = 0ULL;
	guint64 _tmp2_ = 0ULL;
	guint64 unit_g = 0ULL;
	guint64 _tmp3_ = 0ULL;
	guint64 unit_t = 0ULL;
	gchar* txt = NULL;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* result;
#line 372 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (unit != NULL, NULL);
#line 376 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 376 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1024;
#line 2216 "TeeJee.FileSystem.c"
	} else {
#line 376 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1000;
#line 2220 "TeeJee.FileSystem.c"
	}
#line 376 "Utility/TeeJee.FileSystem.vala"
	unit_k = (guint64) _tmp0_;
#line 377 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 377 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1024 * unit_k;
#line 2228 "TeeJee.FileSystem.c"
	} else {
#line 377 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1000 * unit_k;
#line 2232 "TeeJee.FileSystem.c"
	}
#line 377 "Utility/TeeJee.FileSystem.vala"
	unit_m = _tmp1_;
#line 378 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 378 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = 1024 * unit_m;
#line 2240 "TeeJee.FileSystem.c"
	} else {
#line 378 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = 1000 * unit_m;
#line 2244 "TeeJee.FileSystem.c"
	}
#line 378 "Utility/TeeJee.FileSystem.vala"
	unit_g = _tmp2_;
#line 379 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 379 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = 1024 * unit_g;
#line 2252 "TeeJee.FileSystem.c"
	} else {
#line 379 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = 1000 * unit_g;
#line 2256 "TeeJee.FileSystem.c"
	}
#line 379 "Utility/TeeJee.FileSystem.vala"
	unit_t = _tmp3_;
#line 383 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_strdup ("");
#line 383 "Utility/TeeJee.FileSystem.vala"
	txt = _tmp4_;
#line 385 "Utility/TeeJee.FileSystem.vala"
	if (size > unit_t) {
#line 2266 "TeeJee.FileSystem.c"
		gboolean _tmp6_ = FALSE;
		gint _tmp7_;
		gint _tmp8_;
#line 385 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = strlen (unit);
#line 385 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 385 "Utility/TeeJee.FileSystem.vala"
		if (_tmp8_ == 0) {
#line 385 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = TRUE;
#line 2278 "TeeJee.FileSystem.c"
		} else {
#line 385 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_strcmp0 (unit, "t") == 0;
#line 2282 "TeeJee.FileSystem.c"
		}
#line 385 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp6_;
#line 2286 "TeeJee.FileSystem.c"
	} else {
#line 385 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = FALSE;
#line 2290 "TeeJee.FileSystem.c"
	}
#line 385 "Utility/TeeJee.FileSystem.vala"
	if (_tmp5_) {
#line 2294 "TeeJee.FileSystem.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 386 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = txt;
#line 386 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = g_strdup_printf ("%%'0.%df", decimals);
#line 386 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = _tmp10_;
#line 386 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup_printf (_tmp11_, size / (1.0 * unit_t));
#line 386 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_;
#line 386 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 386 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 386 "Utility/TeeJee.FileSystem.vala"
		txt = _tmp14_;
#line 386 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp13_);
#line 386 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp11_);
#line 387 "Utility/TeeJee.FileSystem.vala"
		if (show_units) {
#line 2323 "TeeJee.FileSystem.c"
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 388 "Utility/TeeJee.FileSystem.vala"
			if (binary_units) {
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp15_ = "Ti";
#line 2333 "TeeJee.FileSystem.c"
			} else {
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp15_ = "T";
#line 2337 "TeeJee.FileSystem.c"
			}
#line 388 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = txt;
#line 388 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = g_strdup_printf (" %sB", _tmp15_);
#line 388 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = _tmp17_;
#line 388 "Utility/TeeJee.FileSystem.vala"
			_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 388 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 388 "Utility/TeeJee.FileSystem.vala"
			txt = _tmp19_;
#line 388 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp18_);
#line 2353 "TeeJee.FileSystem.c"
		}
	} else {
		gboolean _tmp20_ = FALSE;
#line 391 "Utility/TeeJee.FileSystem.vala"
		if (size > unit_g) {
#line 2359 "TeeJee.FileSystem.c"
			gboolean _tmp21_ = FALSE;
			gint _tmp22_;
			gint _tmp23_;
#line 391 "Utility/TeeJee.FileSystem.vala"
			_tmp22_ = strlen (unit);
#line 391 "Utility/TeeJee.FileSystem.vala"
			_tmp23_ = _tmp22_;
#line 391 "Utility/TeeJee.FileSystem.vala"
			if (_tmp23_ == 0) {
#line 391 "Utility/TeeJee.FileSystem.vala"
				_tmp21_ = TRUE;
#line 2371 "TeeJee.FileSystem.c"
			} else {
#line 391 "Utility/TeeJee.FileSystem.vala"
				_tmp21_ = g_strcmp0 (unit, "g") == 0;
#line 2375 "TeeJee.FileSystem.c"
			}
#line 391 "Utility/TeeJee.FileSystem.vala"
			_tmp20_ = _tmp21_;
#line 2379 "TeeJee.FileSystem.c"
		} else {
#line 391 "Utility/TeeJee.FileSystem.vala"
			_tmp20_ = FALSE;
#line 2383 "TeeJee.FileSystem.c"
		}
#line 391 "Utility/TeeJee.FileSystem.vala"
		if (_tmp20_) {
#line 2387 "TeeJee.FileSystem.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
#line 392 "Utility/TeeJee.FileSystem.vala"
			_tmp24_ = txt;
#line 392 "Utility/TeeJee.FileSystem.vala"
			_tmp25_ = g_strdup_printf ("%%'0.%df", decimals);
#line 392 "Utility/TeeJee.FileSystem.vala"
			_tmp26_ = _tmp25_;
#line 392 "Utility/TeeJee.FileSystem.vala"
			_tmp27_ = g_strdup_printf (_tmp26_, size / (1.0 * unit_g));
#line 392 "Utility/TeeJee.FileSystem.vala"
			_tmp28_ = _tmp27_;
#line 392 "Utility/TeeJee.FileSystem.vala"
			_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 392 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 392 "Utility/TeeJee.FileSystem.vala"
			txt = _tmp29_;
#line 392 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp28_);
#line 392 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp26_);
#line 393 "Utility/TeeJee.FileSystem.vala"
			if (show_units) {
#line 2416 "TeeJee.FileSystem.c"
				const gchar* _tmp30_ = NULL;
				const gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
#line 394 "Utility/TeeJee.FileSystem.vala"
				if (binary_units) {
#line 394 "Utility/TeeJee.FileSystem.vala"
					_tmp30_ = "Gi";
#line 2426 "TeeJee.FileSystem.c"
				} else {
#line 394 "Utility/TeeJee.FileSystem.vala"
					_tmp30_ = "G";
#line 2430 "TeeJee.FileSystem.c"
				}
#line 394 "Utility/TeeJee.FileSystem.vala"
				_tmp31_ = txt;
#line 394 "Utility/TeeJee.FileSystem.vala"
				_tmp32_ = g_strdup_printf (" %sB", _tmp30_);
#line 394 "Utility/TeeJee.FileSystem.vala"
				_tmp33_ = _tmp32_;
#line 394 "Utility/TeeJee.FileSystem.vala"
				_tmp34_ = g_strconcat (_tmp31_, _tmp33_, NULL);
#line 394 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 394 "Utility/TeeJee.FileSystem.vala"
				txt = _tmp34_;
#line 394 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp33_);
#line 2446 "TeeJee.FileSystem.c"
			}
		} else {
			gboolean _tmp35_ = FALSE;
#line 397 "Utility/TeeJee.FileSystem.vala"
			if (size > unit_m) {
#line 2452 "TeeJee.FileSystem.c"
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gint _tmp38_;
#line 397 "Utility/TeeJee.FileSystem.vala"
				_tmp37_ = strlen (unit);
#line 397 "Utility/TeeJee.FileSystem.vala"
				_tmp38_ = _tmp37_;
#line 397 "Utility/TeeJee.FileSystem.vala"
				if (_tmp38_ == 0) {
#line 397 "Utility/TeeJee.FileSystem.vala"
					_tmp36_ = TRUE;
#line 2464 "TeeJee.FileSystem.c"
				} else {
#line 397 "Utility/TeeJee.FileSystem.vala"
					_tmp36_ = g_strcmp0 (unit, "m") == 0;
#line 2468 "TeeJee.FileSystem.c"
				}
#line 397 "Utility/TeeJee.FileSystem.vala"
				_tmp35_ = _tmp36_;
#line 2472 "TeeJee.FileSystem.c"
			} else {
#line 397 "Utility/TeeJee.FileSystem.vala"
				_tmp35_ = FALSE;
#line 2476 "TeeJee.FileSystem.c"
			}
#line 397 "Utility/TeeJee.FileSystem.vala"
			if (_tmp35_) {
#line 2480 "TeeJee.FileSystem.c"
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 398 "Utility/TeeJee.FileSystem.vala"
				_tmp39_ = txt;
#line 398 "Utility/TeeJee.FileSystem.vala"
				_tmp40_ = g_strdup_printf ("%%'0.%df", decimals);
#line 398 "Utility/TeeJee.FileSystem.vala"
				_tmp41_ = _tmp40_;
#line 398 "Utility/TeeJee.FileSystem.vala"
				_tmp42_ = g_strdup_printf (_tmp41_, size / (1.0 * unit_m));
#line 398 "Utility/TeeJee.FileSystem.vala"
				_tmp43_ = _tmp42_;
#line 398 "Utility/TeeJee.FileSystem.vala"
				_tmp44_ = g_strconcat (_tmp39_, _tmp43_, NULL);
#line 398 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 398 "Utility/TeeJee.FileSystem.vala"
				txt = _tmp44_;
#line 398 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp43_);
#line 398 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp41_);
#line 399 "Utility/TeeJee.FileSystem.vala"
				if (show_units) {
#line 2509 "TeeJee.FileSystem.c"
					const gchar* _tmp45_ = NULL;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
#line 400 "Utility/TeeJee.FileSystem.vala"
					if (binary_units) {
#line 400 "Utility/TeeJee.FileSystem.vala"
						_tmp45_ = "Mi";
#line 2519 "TeeJee.FileSystem.c"
					} else {
#line 400 "Utility/TeeJee.FileSystem.vala"
						_tmp45_ = "M";
#line 2523 "TeeJee.FileSystem.c"
					}
#line 400 "Utility/TeeJee.FileSystem.vala"
					_tmp46_ = txt;
#line 400 "Utility/TeeJee.FileSystem.vala"
					_tmp47_ = g_strdup_printf (" %sB", _tmp45_);
#line 400 "Utility/TeeJee.FileSystem.vala"
					_tmp48_ = _tmp47_;
#line 400 "Utility/TeeJee.FileSystem.vala"
					_tmp49_ = g_strconcat (_tmp46_, _tmp48_, NULL);
#line 400 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 400 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp49_;
#line 400 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp48_);
#line 2539 "TeeJee.FileSystem.c"
				}
			} else {
				gboolean _tmp50_ = FALSE;
#line 403 "Utility/TeeJee.FileSystem.vala"
				if (size > unit_k) {
#line 2545 "TeeJee.FileSystem.c"
					gboolean _tmp51_ = FALSE;
					gint _tmp52_;
					gint _tmp53_;
#line 403 "Utility/TeeJee.FileSystem.vala"
					_tmp52_ = strlen (unit);
#line 403 "Utility/TeeJee.FileSystem.vala"
					_tmp53_ = _tmp52_;
#line 403 "Utility/TeeJee.FileSystem.vala"
					if (_tmp53_ == 0) {
#line 403 "Utility/TeeJee.FileSystem.vala"
						_tmp51_ = TRUE;
#line 2557 "TeeJee.FileSystem.c"
					} else {
#line 403 "Utility/TeeJee.FileSystem.vala"
						_tmp51_ = g_strcmp0 (unit, "k") == 0;
#line 2561 "TeeJee.FileSystem.c"
					}
#line 403 "Utility/TeeJee.FileSystem.vala"
					_tmp50_ = _tmp51_;
#line 2565 "TeeJee.FileSystem.c"
				} else {
#line 403 "Utility/TeeJee.FileSystem.vala"
					_tmp50_ = FALSE;
#line 2569 "TeeJee.FileSystem.c"
				}
#line 403 "Utility/TeeJee.FileSystem.vala"
				if (_tmp50_) {
#line 2573 "TeeJee.FileSystem.c"
					const gchar* _tmp54_;
					gchar* _tmp55_;
					gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
#line 404 "Utility/TeeJee.FileSystem.vala"
					_tmp54_ = txt;
#line 404 "Utility/TeeJee.FileSystem.vala"
					_tmp55_ = g_strdup_printf ("%%'0.%df", decimals);
#line 404 "Utility/TeeJee.FileSystem.vala"
					_tmp56_ = _tmp55_;
#line 404 "Utility/TeeJee.FileSystem.vala"
					_tmp57_ = g_strdup_printf (_tmp56_, size / (1.0 * unit_k));
#line 404 "Utility/TeeJee.FileSystem.vala"
					_tmp58_ = _tmp57_;
#line 404 "Utility/TeeJee.FileSystem.vala"
					_tmp59_ = g_strconcat (_tmp54_, _tmp58_, NULL);
#line 404 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 404 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp59_;
#line 404 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp58_);
#line 404 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp56_);
#line 405 "Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 2602 "TeeJee.FileSystem.c"
						const gchar* _tmp60_ = NULL;
						const gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
#line 406 "Utility/TeeJee.FileSystem.vala"
						if (binary_units) {
#line 406 "Utility/TeeJee.FileSystem.vala"
							_tmp60_ = "Ki";
#line 2612 "TeeJee.FileSystem.c"
						} else {
#line 406 "Utility/TeeJee.FileSystem.vala"
							_tmp60_ = "K";
#line 2616 "TeeJee.FileSystem.c"
						}
#line 406 "Utility/TeeJee.FileSystem.vala"
						_tmp61_ = txt;
#line 406 "Utility/TeeJee.FileSystem.vala"
						_tmp62_ = g_strdup_printf (" %sB", _tmp60_);
#line 406 "Utility/TeeJee.FileSystem.vala"
						_tmp63_ = _tmp62_;
#line 406 "Utility/TeeJee.FileSystem.vala"
						_tmp64_ = g_strconcat (_tmp61_, _tmp63_, NULL);
#line 406 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 406 "Utility/TeeJee.FileSystem.vala"
						txt = _tmp64_;
#line 406 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (_tmp63_);
#line 2632 "TeeJee.FileSystem.c"
					}
				} else {
					const gchar* _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					gchar* _tmp68_;
#line 410 "Utility/TeeJee.FileSystem.vala"
					_tmp65_ = txt;
#line 410 "Utility/TeeJee.FileSystem.vala"
					_tmp66_ = g_strdup_printf ("%'0lld", size);
#line 410 "Utility/TeeJee.FileSystem.vala"
					_tmp67_ = _tmp66_;
#line 410 "Utility/TeeJee.FileSystem.vala"
					_tmp68_ = g_strconcat (_tmp65_, _tmp67_, NULL);
#line 410 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 410 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp68_;
#line 410 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp67_);
#line 411 "Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 2655 "TeeJee.FileSystem.c"
						const gchar* _tmp69_;
						gchar* _tmp70_;
#line 412 "Utility/TeeJee.FileSystem.vala"
						_tmp69_ = txt;
#line 412 "Utility/TeeJee.FileSystem.vala"
						_tmp70_ = g_strconcat (_tmp69_, " B", NULL);
#line 412 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 412 "Utility/TeeJee.FileSystem.vala"
						txt = _tmp70_;
#line 2666 "TeeJee.FileSystem.c"
					}
				}
			}
		}
	}
#line 418 "Utility/TeeJee.FileSystem.vala"
	result = txt;
#line 418 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2676 "TeeJee.FileSystem.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2698 "TeeJee.FileSystem.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2702 "TeeJee.FileSystem.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2708 "TeeJee.FileSystem.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2712 "TeeJee.FileSystem.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2716 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 2724 "TeeJee.FileSystem.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2752 "TeeJee.FileSystem.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 2761 "TeeJee.FileSystem.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2775 "TeeJee.FileSystem.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 2784 "TeeJee.FileSystem.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 2798 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2807 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 2816 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_escape_single_quote (const gchar* file_path)
{
	gchar* _tmp0_;
	gchar* result;
#line 421 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 423 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = string_replace (file_path, "'", "'\\''");
#line 423 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 423 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2832 "TeeJee.FileSystem.c"
}

gint
tee_jee_file_system_chmod (const gchar* file,
                           const gchar* permission)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint result;
#line 427 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 427 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (permission != NULL, 0);
#line 429 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file);
#line 429 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 429 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chmod %s '%s'", permission, _tmp1_);
#line 429 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 429 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 429 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 430 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 430 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 430 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2867 "TeeJee.FileSystem.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

