/* TeeJee.Json.c generated by valac 0.56.17, the Vala compiler
 * generated from TeeJee.Json.vala, do not modify */

/*
 * TeeJee.JsonHelper.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gchar* tee_jee_json_helper_json_get_string (JsonObject* jobj,
                                            const gchar* member,
                                            const gchar* def_value);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
VALA_EXTERN gboolean tee_jee_json_helper_json_get_bool (JsonObject* jobj,
                                            const gchar* member,
                                            gboolean def_value);
VALA_EXTERN gint tee_jee_json_helper_json_get_int (JsonObject* jobj,
                                       const gchar* member,
                                       gint def_value);
VALA_EXTERN guint64 tee_jee_json_helper_json_get_uint64 (JsonObject* jobj,
                                             const gchar* member,
                                             guint64 def_value);

gchar*
tee_jee_json_helper_json_get_string (JsonObject* jobj,
                                     const gchar* member,
                                     const gchar* def_value)
{
	gchar* result;
#line 33 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, NULL);
#line 33 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, NULL);
#line 33 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (def_value != NULL, NULL);
#line 34 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 81 "TeeJee.Json.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 35 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 35 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 35 "Utility/TeeJee.Json.vala"
		result = _tmp1_;
#line 35 "Utility/TeeJee.Json.vala"
		return result;
#line 92 "TeeJee.Json.c"
	} else {
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 38 "Utility/TeeJee.Json.vala"
		_tmp2_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 38 "Utility/TeeJee.Json.vala"
		_tmp3_ = _tmp2_;
#line 38 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp3_);
#line 38 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp3_);
#line 39 "Utility/TeeJee.Json.vala"
		_tmp4_ = g_strdup (def_value);
#line 39 "Utility/TeeJee.Json.vala"
		result = _tmp4_;
#line 39 "Utility/TeeJee.Json.vala"
		return result;
#line 111 "TeeJee.Json.c"
	}
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 127 "TeeJee.Json.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 133 "TeeJee.Json.c"
	}
}

gboolean
tee_jee_json_helper_json_get_bool (JsonObject* jobj,
                                   const gchar* member,
                                   gboolean def_value)
{
	gboolean result;
#line 43 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, FALSE);
#line 43 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, FALSE);
#line 44 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 149 "TeeJee.Json.c"
		const gchar* _tmp0_;
#line 45 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 45 "Utility/TeeJee.Json.vala"
		result = bool_parse (_tmp0_);
#line 45 "Utility/TeeJee.Json.vala"
		return result;
#line 157 "TeeJee.Json.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 48 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 48 "Utility/TeeJee.Json.vala"
		_tmp2_ = _tmp1_;
#line 48 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 48 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp2_);
#line 49 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 49 "Utility/TeeJee.Json.vala"
		return result;
#line 173 "TeeJee.Json.c"
	}
}

gint
tee_jee_json_helper_json_get_int (JsonObject* jobj,
                                  const gchar* member,
                                  gint def_value)
{
	gint result;
#line 53 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, 0);
#line 53 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, 0);
#line 54 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 189 "TeeJee.Json.c"
		const gchar* _tmp0_;
#line 55 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 55 "Utility/TeeJee.Json.vala"
		result = atoi (_tmp0_);
#line 55 "Utility/TeeJee.Json.vala"
		return result;
#line 197 "TeeJee.Json.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 58 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 58 "Utility/TeeJee.Json.vala"
		_tmp2_ = _tmp1_;
#line 58 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 58 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp2_);
#line 59 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 59 "Utility/TeeJee.Json.vala"
		return result;
#line 213 "TeeJee.Json.c"
	}
}

static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 839 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 840 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 840 "glib-2.0.vapi"
	return result;
#line 228 "TeeJee.Json.c"
}

guint64
tee_jee_json_helper_json_get_uint64 (JsonObject* jobj,
                                     const gchar* member,
                                     guint64 def_value)
{
	guint64 result;
#line 63 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, 0ULL);
#line 63 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, 0ULL);
#line 64 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 243 "TeeJee.Json.c"
		const gchar* _tmp0_;
#line 65 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 65 "Utility/TeeJee.Json.vala"
		result = uint64_parse (_tmp0_, (guint) 0);
#line 65 "Utility/TeeJee.Json.vala"
		return result;
#line 251 "TeeJee.Json.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 68 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 68 "Utility/TeeJee.Json.vala"
		_tmp2_ = _tmp1_;
#line 68 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 68 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp2_);
#line 69 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 69 "Utility/TeeJee.Json.vala"
		return result;
#line 267 "TeeJee.Json.c"
	}
}

