/* TimeoutCounter.c generated by valac 0.56.17, the Vala compiler
 * generated from TimeoutCounter.vala, do not modify */

/*
 * TimeoutCounter.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define TIMEOUT_COUNTER_DEFAULT_SECONDS_TO_WAIT 60
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;
typedef struct _TimeoutCounterPrivate TimeoutCounterPrivate;
enum  {
	TIMEOUT_COUNTER_0_PROPERTY,
	TIMEOUT_COUNTER_NUM_PROPERTIES
};
static GParamSpec* timeout_counter_properties[TIMEOUT_COUNTER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TimeoutCounter {
	GObject parent_instance;
	TimeoutCounterPrivate * priv;
	gboolean active;
	gchar* process_to_kill;
	gint seconds_to_wait;
	gboolean exit_app;
};

struct _TimeoutCounterClass {
	GObjectClass parent_class;
};

static gpointer timeout_counter_parent_class = NULL;

VALA_EXTERN GType timeout_counter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TimeoutCounter, g_object_unref)
VALA_EXTERN void timeout_counter_kill_process_on_timeout (TimeoutCounter* self,
                                              const gchar* process_to_kill,
                                              gint seconds_to_wait,
                                              gboolean exit_app);
VALA_EXTERN void timeout_counter_start_counter_thread (TimeoutCounter* self);
static gpointer _timeout_counter_start_counter_thread_gthread_func (gpointer self);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
VALA_EXTERN void timeout_counter_exit_on_timeout (TimeoutCounter* self,
                                      gint seconds_to_wait);
VALA_EXTERN void timeout_counter_stop (TimeoutCounter* self);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
void exit (gint exit_code);
VALA_EXTERN TimeoutCounter* timeout_counter_new (void);
VALA_EXTERN TimeoutCounter* timeout_counter_construct (GType object_type);
static void timeout_counter_finalize (GObject * obj);
static GType timeout_counter_get_type_once (void);

static gpointer
_timeout_counter_start_counter_thread_gthread_func (gpointer self)
{
	gpointer result;
#line 47 "Utility/TimeoutCounter.vala"
	timeout_counter_start_counter_thread ((TimeoutCounter*) self);
#line 113 "TimeoutCounter.c"
	result = NULL;
#line 47 "Utility/TimeoutCounter.vala"
	g_object_unref (self);
#line 47 "Utility/TimeoutCounter.vala"
	return result;
#line 119 "TimeoutCounter.c"
}

void
timeout_counter_kill_process_on_timeout (TimeoutCounter* self,
                                         const gchar* process_to_kill,
                                         gint seconds_to_wait,
                                         gboolean exit_app)
{
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 38 "Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 38 "Utility/TimeoutCounter.vala"
	g_return_if_fail (process_to_kill != NULL);
#line 41 "Utility/TimeoutCounter.vala"
	_tmp0_ = g_strdup (process_to_kill);
#line 41 "Utility/TimeoutCounter.vala"
	_g_free0 (self->process_to_kill);
#line 41 "Utility/TimeoutCounter.vala"
	self->process_to_kill = _tmp0_;
#line 42 "Utility/TimeoutCounter.vala"
	self->seconds_to_wait = seconds_to_wait;
#line 43 "Utility/TimeoutCounter.vala"
	self->exit_app = exit_app;
#line 144 "TimeoutCounter.c"
	{
#line 46 "Utility/TimeoutCounter.vala"
		self->active = TRUE;
#line 47 "Utility/TimeoutCounter.vala"
		g_thread_create (_timeout_counter_start_counter_thread_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 47 "Utility/TimeoutCounter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "TimeoutCounter.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 45 "Utility/TimeoutCounter.vala"
		e = _inner_error0_;
#line 45 "Utility/TimeoutCounter.vala"
		_inner_error0_ = NULL;
#line 50 "Utility/TimeoutCounter.vala"
		_tmp1_ = e;
#line 50 "Utility/TimeoutCounter.vala"
		_tmp2_ = _tmp1_->message;
#line 50 "Utility/TimeoutCounter.vala"
		tee_jee_logging_log_error (_tmp2_, FALSE, FALSE);
#line 45 "Utility/TimeoutCounter.vala"
		_g_error_free0 (e);
#line 174 "TimeoutCounter.c"
	}
	__finally0:
#line 45 "Utility/TimeoutCounter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "Utility/TimeoutCounter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 45 "Utility/TimeoutCounter.vala"
		g_clear_error (&_inner_error0_);
#line 45 "Utility/TimeoutCounter.vala"
		return;
#line 185 "TimeoutCounter.c"
	}
}

void
timeout_counter_exit_on_timeout (TimeoutCounter* self,
                                 gint seconds_to_wait)
{
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 54 "Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 55 "Utility/TimeoutCounter.vala"
	_tmp0_ = g_strdup ("");
#line 55 "Utility/TimeoutCounter.vala"
	_g_free0 (self->process_to_kill);
#line 55 "Utility/TimeoutCounter.vala"
	self->process_to_kill = _tmp0_;
#line 56 "Utility/TimeoutCounter.vala"
	self->seconds_to_wait = seconds_to_wait;
#line 57 "Utility/TimeoutCounter.vala"
	self->exit_app = TRUE;
#line 207 "TimeoutCounter.c"
	{
#line 60 "Utility/TimeoutCounter.vala"
		self->active = TRUE;
#line 61 "Utility/TimeoutCounter.vala"
		g_thread_create (_timeout_counter_start_counter_thread_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 61 "Utility/TimeoutCounter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "TimeoutCounter.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 59 "Utility/TimeoutCounter.vala"
		e = _inner_error0_;
#line 59 "Utility/TimeoutCounter.vala"
		_inner_error0_ = NULL;
#line 64 "Utility/TimeoutCounter.vala"
		_tmp1_ = e;
#line 64 "Utility/TimeoutCounter.vala"
		_tmp2_ = _tmp1_->message;
#line 64 "Utility/TimeoutCounter.vala"
		tee_jee_logging_log_error (_tmp2_, FALSE, FALSE);
#line 59 "Utility/TimeoutCounter.vala"
		_g_error_free0 (e);
#line 237 "TimeoutCounter.c"
	}
	__finally0:
#line 59 "Utility/TimeoutCounter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "Utility/TimeoutCounter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "Utility/TimeoutCounter.vala"
		g_clear_error (&_inner_error0_);
#line 59 "Utility/TimeoutCounter.vala"
		return;
#line 248 "TimeoutCounter.c"
	}
}

void
timeout_counter_stop (TimeoutCounter* self)
{
#line 68 "Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 69 "Utility/TimeoutCounter.vala"
	self->active = FALSE;
#line 259 "TimeoutCounter.c"
}

void
timeout_counter_start_counter_thread (TimeoutCounter* self)
{
	gint secs = 0;
#line 72 "Utility/TimeoutCounter.vala"
	g_return_if_fail (self != NULL);
#line 73 "Utility/TimeoutCounter.vala"
	secs = 0;
#line 75 "Utility/TimeoutCounter.vala"
	while (TRUE) {
#line 272 "TimeoutCounter.c"
		gboolean _tmp0_ = FALSE;
#line 75 "Utility/TimeoutCounter.vala"
		if (self->active) {
#line 75 "Utility/TimeoutCounter.vala"
			_tmp0_ = secs < self->seconds_to_wait;
#line 278 "TimeoutCounter.c"
		} else {
#line 75 "Utility/TimeoutCounter.vala"
			_tmp0_ = FALSE;
#line 282 "TimeoutCounter.c"
		}
#line 75 "Utility/TimeoutCounter.vala"
		if (!_tmp0_) {
#line 75 "Utility/TimeoutCounter.vala"
			break;
#line 288 "TimeoutCounter.c"
		}
#line 76 "Utility/TimeoutCounter.vala"
		g_usleep (((gulong) G_TIME_SPAN_MILLISECOND) * 1000);
#line 77 "Utility/TimeoutCounter.vala"
		secs += 1;
#line 294 "TimeoutCounter.c"
	}
#line 80 "Utility/TimeoutCounter.vala"
	if (self->active) {
#line 298 "TimeoutCounter.c"
		FILE* _tmp1_;
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 81 "Utility/TimeoutCounter.vala"
		self->active = FALSE;
#line 82 "Utility/TimeoutCounter.vala"
		_tmp1_ = stdout;
#line 82 "Utility/TimeoutCounter.vala"
		fprintf (_tmp1_, "\n");
#line 84 "Utility/TimeoutCounter.vala"
		_tmp2_ = self->process_to_kill;
#line 84 "Utility/TimeoutCounter.vala"
		_tmp3_ = strlen (_tmp2_);
#line 84 "Utility/TimeoutCounter.vala"
		_tmp4_ = _tmp3_;
#line 84 "Utility/TimeoutCounter.vala"
		if (_tmp4_ > 0) {
#line 317 "TimeoutCounter.c"
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 85 "Utility/TimeoutCounter.vala"
			_tmp5_ = self->process_to_kill;
#line 85 "Utility/TimeoutCounter.vala"
			_tmp6_ = g_strconcat ("killall ", _tmp5_, NULL);
#line 85 "Utility/TimeoutCounter.vala"
			_tmp7_ = _tmp6_;
#line 85 "Utility/TimeoutCounter.vala"
			system (_tmp7_);
#line 85 "Utility/TimeoutCounter.vala"
			_g_free0 (_tmp7_);
#line 86 "Utility/TimeoutCounter.vala"
			_tmp8_ = self->process_to_kill;
#line 86 "Utility/TimeoutCounter.vala"
			_tmp9_ = g_strdup_printf (": %s", _tmp8_);
#line 86 "Utility/TimeoutCounter.vala"
			_tmp10_ = _tmp9_;
#line 86 "Utility/TimeoutCounter.vala"
			_tmp11_ = g_strconcat ("[timeout] Killed process", _tmp10_, NULL);
#line 86 "Utility/TimeoutCounter.vala"
			_tmp12_ = _tmp11_;
#line 86 "Utility/TimeoutCounter.vala"
			tee_jee_logging_log_debug (_tmp12_);
#line 86 "Utility/TimeoutCounter.vala"
			_g_free0 (_tmp12_);
#line 86 "Utility/TimeoutCounter.vala"
			_g_free0 (_tmp10_);
#line 352 "TimeoutCounter.c"
		}
#line 89 "Utility/TimeoutCounter.vala"
		if (self->exit_app) {
#line 90 "Utility/TimeoutCounter.vala"
			tee_jee_logging_log_debug ("[timeout] Exit application");
#line 91 "Utility/TimeoutCounter.vala"
			exit (0);
#line 360 "TimeoutCounter.c"
		}
	}
}

TimeoutCounter*
timeout_counter_construct (GType object_type)
{
	TimeoutCounter * self = NULL;
#line 30 "Utility/TimeoutCounter.vala"
	self = (TimeoutCounter*) g_object_new (object_type, NULL);
#line 30 "Utility/TimeoutCounter.vala"
	return self;
#line 373 "TimeoutCounter.c"
}

TimeoutCounter*
timeout_counter_new (void)
{
#line 30 "Utility/TimeoutCounter.vala"
	return timeout_counter_construct (TYPE_TIMEOUT_COUNTER);
#line 381 "TimeoutCounter.c"
}

static void
timeout_counter_class_init (TimeoutCounterClass * klass,
                            gpointer klass_data)
{
#line 30 "Utility/TimeoutCounter.vala"
	timeout_counter_parent_class = g_type_class_peek_parent (klass);
#line 30 "Utility/TimeoutCounter.vala"
	G_OBJECT_CLASS (klass)->finalize = timeout_counter_finalize;
#line 392 "TimeoutCounter.c"
}

static void
timeout_counter_instance_init (TimeoutCounter * self,
                               gpointer klass)
{
	gchar* _tmp0_;
#line 32 "Utility/TimeoutCounter.vala"
	self->active = FALSE;
#line 33 "Utility/TimeoutCounter.vala"
	_tmp0_ = g_strdup ("");
#line 33 "Utility/TimeoutCounter.vala"
	self->process_to_kill = _tmp0_;
#line 35 "Utility/TimeoutCounter.vala"
	self->seconds_to_wait = 60;
#line 36 "Utility/TimeoutCounter.vala"
	self->exit_app = FALSE;
#line 410 "TimeoutCounter.c"
}

static void
timeout_counter_finalize (GObject * obj)
{
	TimeoutCounter * self;
#line 30 "Utility/TimeoutCounter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMEOUT_COUNTER, TimeoutCounter);
#line 33 "Utility/TimeoutCounter.vala"
	_g_free0 (self->process_to_kill);
#line 30 "Utility/TimeoutCounter.vala"
	G_OBJECT_CLASS (timeout_counter_parent_class)->finalize (obj);
#line 423 "TimeoutCounter.c"
}

static GType
timeout_counter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TimeoutCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timeout_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimeoutCounter), 0, (GInstanceInitFunc) timeout_counter_instance_init, NULL };
	GType timeout_counter_type_id;
	timeout_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "TimeoutCounter", &g_define_type_info, 0);
	return timeout_counter_type_id;
}

GType
timeout_counter_get_type (void)
{
	static volatile gsize timeout_counter_type_id__once = 0;
	if (g_once_init_enter (&timeout_counter_type_id__once)) {
		GType timeout_counter_type_id;
		timeout_counter_type_id = timeout_counter_get_type_once ();
		g_once_init_leave (&timeout_counter_type_id__once, timeout_counter_type_id);
	}
	return timeout_counter_type_id__once;
}

